p20ContentPack = RegisterMod("piber pack", 1)

--load piber20helper
local _, err = pcall(require, "scripts.piberpack.p20helper")
err = tostring(err)
if not string.match(err, "attempt to call a nil value %(field 'ForceError'%)") then
	if string.match(err, "true") then
		err = "Error: require passed in p20helper"
	end
	error(err)
end

--enums
p20CollectibleType.COLLECTIBLE_BOX_PILLS = Isaac.GetItemIdByName("Daily Dose")
p20CollectibleType.COLLECTIBLE_HAMMER = Isaac.GetItemIdByName("The Hammer")
p20CollectibleType.COLLECTIBLE_DIVINE_SHROUD = Isaac.GetItemIdByName("Divine Shroud")
p20CollectibleType.COLLECTIBLE_BATTERY_TESTER = Isaac.GetItemIdByName("Battery Tester")
p20CollectibleType.COLLECTIBLE_BIRTHDAY_CAKE = Isaac.GetItemIdByName("Birthday Cake")
p20CollectibleType.COLLECTIBLE_SPECIAL_BABIES = Isaac.GetItemIdByName("Special Babies!")
p20CollectibleType.COLLECTIBLE_MIXED_VEGGIES = Isaac.GetItemIdByName("Mixed Veggies")
p20CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX = Isaac.GetItemIdByName(" Buddy in a Box ") --reimplemented buddy in a box

p20Card.CARD_CLUBS_5 = Isaac.GetCardIdByName("5OfClubs") --this function is a lie, it gets the card id by the hud value
p20Card.CARD_DIAMONDS_5 = Isaac.GetCardIdByName("5OfDiamonds")
p20Card.CARD_SPADES_5 = Isaac.GetCardIdByName("5OfSpades")
p20Card.CARD_HEARTS_5 = Isaac.GetCardIdByName("5OfHearts")
p20Card.CARD_DEBIT = Isaac.GetCardIdByName("DebitCard")

p20PillColor.PILL_SALMON_SALMON = 33
p20PillColor.PILL_SALMON_SLATE = 34
p20PillColor.PILL_GREEN_SLATE = 35
p20PillColor.PILL_GREEN_PURPLE = 36
p20PillColor.PILL_GREEN_GREEN = 37
p20PillColor.PILL_SLATE_SLATE = 38
p20PillColor.PILL_PURPLE_PURPLE = 39

p20HeartAltSubType.HEART_HOLY = 56 --no GetEntitySubTypeByName function, ugh

p20CoinAltSubType.COIN_PENNY_ALT = 1

p20BatteryAltSubType.BATTERY_LEAKY = 18
p20BatteryAltSubType.BATTERY_DEAD = 19

p20Costume.COSTUME_DIVINE_SHROUD = Isaac.GetCostumeIdByPath("gfx/characters/piberpack/divine_shroud.anm2")
p20Costume.COSTUME_BIRTHDAY_CAKE = Isaac.GetCostumeIdByPath("gfx/characters/piberpack/birthday_cake.anm2")
p20Costume.COSTUME_BIRTHDAY_CAKE_CANDLE = Isaac.GetCostumeIdByPath("gfx/characters/piberpack/birthday_cake_candle.anm2")
p20Costume.COSTUME_MIXED_VEGGIES = Isaac.GetCostumeIdByPath("gfx/characters/piberpack/mixed_veggies.anm2")

p20FamiliarVariant.BASIC_BABY = Isaac.GetEntityVariantByName("Basic Baby")
p20FamiliarVariant.SPECIAL_BABY = Isaac.GetEntityVariantByName("Special Baby")
p20FamiliarVariant.SPECIAL_BABY_FLY_ORBITAL = Isaac.GetEntityVariantByName("Special Baby Fly Orbital")

p20NPCVariant.SLIPPERY_SQUIRT = Isaac.GetEntityVariantByName("Slippery Squirt")
p20NPCVariant.SLIPPERY_DINGA = Isaac.GetEntityVariantByName("Slippery Dinga")
p20NPCSubType.SLIPPERY_DIP = 73
p20NPCSubType.SLIPPERY_CORN = 73

p20NPCVariant.FLOOD = Isaac.GetEntityVariantByName("Flood")
p20NPCVariant.FLOOD_SCARRED = Isaac.GetEntityVariantByName("Scarred Flood")

p20NPCVariant.SPEWER = Isaac.GetEntityVariantByName("Spewer")
p20NPCVariant.SPEWER_DANK = Isaac.GetEntityVariantByName("Dank Spewer")

p20EffectVariant.SLIPPERY_POOP = Isaac.GetEntityVariantByName("Slippery Poop")
p20SlipperyPoopSubType = {
	NORMAL = 73,
	CORNY = 74
}

--getdata
function p20ContentPack.GetData(entity)
	if not entity or (entity and not entity.GetData) then
		return nil
	end
	local data = entity:GetData()
	if data.p20ContentPack == nil then
		data.p20ContentPack = {}
	end
	return data.p20ContentPack
end

--execute the code
p20.Exec("scripts.piberpack.savedata")
p20.Exec("scripts.piberpack.presets")
p20.Exec("scripts.piberpack.credits")
p20.Exec("scripts.piberpack.unlocks")
p20.Exec("scripts.piberpack.config")
p20.Exec("scripts.piberpack.players.babies")
p20.Exec("scripts.piberpack.rooms.bedroom")
p20.Exec("scripts.piberpack.rooms.barren")
p20.Exec("scripts.piberpack.rooms.arcade")
p20.Exec("scripts.piberpack.rooms.dice")
p20.Exec("scripts.piberpack.rooms.error")
p20.Exec("scripts.piberpack.grids.slippery_poop")
p20.Exec("scripts.piberpack.monsters.slippery_poop")
p20.Exec("scripts.piberpack.monsters.flood")
p20.Exec("scripts.piberpack.monsters.spewer")
p20.Exec("scripts.piberpack.items.collectibles.box_pills")
p20.Exec("scripts.piberpack.items.collectibles.the_hammer")
p20.Exec("scripts.piberpack.items.collectibles.divine_shroud")
p20.Exec("scripts.piberpack.items.collectibles.battery_tester")
p20.Exec("scripts.piberpack.items.collectibles.birthday_cake")
p20.Exec("scripts.piberpack.items.collectibles.special_babies")
p20.Exec("scripts.piberpack.items.collectibles.mixed_veggies")
p20.Exec("scripts.piberpack.items.cards.fives")
p20.Exec("scripts.piberpack.items.cards.debit")
p20.Exec("scripts.piberpack.items.pickups.holy_heart")
p20.Exec("scripts.piberpack.items.pickups.leaky_battery")