p20.AddCustomCallback(p20ContentPack, p20Callbacks.MC_POST_FIRST_GAME_START, function(_, isSaveGame)
	if ModConfigMenu then
		---------
		--ITEMS--
		---------
		ModConfigMenu.AddTitle("piber pack", "Items", function()
			if p20.ModSave.Unlocks.ContentPack_DebitCard then
				return "Debit Card"
			else
				return "????? ????"
			end
		end)
		ModConfigMenu.AddSetting("piber pack", "Items", {
			Type = ModConfigMenuOptionType.BOOLEAN,
			CurrentSetting = function()
				return p20.ModSave.Config.Content_DebitCard_RemoveCoin
			end,
			Default = p20.DefaultModSave.Config.Content_DebitCard_RemoveCoin,
			Display = function()
				if p20.ModSave.Unlocks.ContentPack_DebitCard then
					local onOff = "No"
					if p20.ModSave.Config.Content_DebitCard_RemoveCoin then
						onOff = "Yes"
					end
					return "Remove Coin On Use: " .. onOff
				else
					local onOff = "??"
					if p20.ModSave.Config.Content_DebitCard_RemoveCoin then
						onOff = "???"
					end
					return "?????? ???? ?? ???: " .. onOff
				end
			end,
			OnChange = function(currentBool)
				if p20.ModSave.Unlocks.ContentPack_DebitCard then
					p20.ModSave.Config.Content_DebitCard_RemoveCoin = currentBool
				end
			end,
			Info = function()
				if p20.ModSave.Unlocks.ContentPack_DebitCard then
					return {
						"A downside to saving money in the debit card is that",
						"you need to pay to withdraw money. You can turn this",
						"off, however this reduces the challenge."
					}
				else
					return {
						"This setting pertains to something which has not",
						"been unlocked. You cannot change this right now."
					}
				end
			end
		})
		
		ModConfigMenu.AddSpace("piber pack", "Items")
		
		ModConfigMenu.AddTitle("piber pack", "Items", "Buddy in a Box")
		ModConfigMenu.AddSetting("piber pack", "Items", {
			Type = ModConfigMenuOptionType.BOOLEAN,
			CurrentSetting = function()
				return p20.ModSave.Config.Content_BuddyBox_Reimplement
			end,
			Default = p20.DefaultModSave.Config.Content_BuddyBox_Reimplement,
			Display = function()
				local onOff = "No"
				if p20.ModSave.Config.Content_BuddyBox_Reimplement then
					onOff = "Yes"
				end
				return "Enable Reimplementation: " .. onOff
			end,
			OnChange = function(currentBool)
				p20.ModSave.Config.Content_BuddyBox_Reimplement = currentBool
			end,
			Info = {
				"Overwrites the default Buddy in a Box with",
				"a custom version. Instead of random tears, some",
				"attributes are copied from the player's tears."
			}
		})
		
		------------
		--MONSTERS--
		------------
		ModConfigMenu.AddTitle("piber pack", "Monsters", "Slippery Poop")
		ModConfigMenu.AddSetting("piber pack", "Monsters", {
			Type = ModConfigMenuOptionType.BOOLEAN,
			CurrentSetting = function()
				return p20.ModSave.Config.Content_SlipperyPoop_ReplacePoops
			end,
			Default = p20.DefaultModSave.Config.Content_SlipperyPoop_ReplacePoops,
			Display = function()
				local onOff = "No"
				if p20.ModSave.Config.Content_SlipperyPoop_ReplacePoops then
					onOff = "Yes"
				end
				return "Replace in Flooded Caves: " .. onOff
			end,
			OnChange = function(currentBool)
				p20.ModSave.Config.Content_SlipperyPoop_ReplacePoops = currentBool
			end,
			Info = {
				"Replaces regular Dips, Squirts, and Dingas with",
				"Slippery versions in Flooded Caves."
			}
		})
	end
end)


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally