p20ContentPack.GridSlipperyPoop = nil --these get filled in later if stageapi exists
p20ContentPack.GridSlipperyPoopCorny = nil

local poopSpawnIndexes = {}
p20ContentPack:AddCallback(ModCallbacks.MC_PRE_ENTITY_SPAWN, function(_, entType, entVariant, entSubType, position, velocity, spawner, seed)
	if entType == EntityType.ENTITY_EFFECT and entVariant == p20EffectVariant.SLIPPERY_POOP then
	
		local spawnSlipperyPoopType = -1
		if entSubType == p20SlipperyPoopSubType.NORMAL then
			if not spawner and p20.GetRandomNumber(1, 100, seed) <= 5 then
				spawnSlipperyPoopType = p20SlipperyPoopSubType.CORNY
			else
				spawnSlipperyPoopType = p20SlipperyPoopSubType.NORMAL
			end
		elseif entSubType == p20SlipperyPoopSubType.CORNY then
			spawnSlipperyPoopType = p20SlipperyPoopSubType.CORNY
		end
		
		local returnDeleteMe = false
		if spawnSlipperyPoopType == p20SlipperyPoopSubType.NORMAL then
			poopSpawnIndexes[p20.Room:GetGridIndex(position)] = p20SlipperyPoopSubType.NORMAL
			returnDeleteMe = true
		elseif spawnSlipperyPoopType == p20SlipperyPoopSubType.CORNY then
			poopSpawnIndexes[p20.Room:GetGridIndex(position)] = p20SlipperyPoopSubType.CORNY
			returnDeleteMe = true
		end
		
		--[[
		if returnDeleteMe and StageAPI and StageAPI.E and StageAPI.E.DeleteMeEffect then
			return {
				StageAPI.E.DeleteMeEffect.T,
				StageAPI.E.DeleteMeEffect.V,
				0,
				seed
			}
		end
		]]
		
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_NEW_ROOM, function()
	for index,subtype in pairs(poopSpawnIndexes) do
	
		if subtype == p20SlipperyPoopSubType.NORMAL then
		
			if p20ContentPack.GridSlipperyPoop then
				p20ContentPack.GridSlipperyPoop:Spawn(index, true, false)
			else
				Isaac.GridSpawn(GridEntityType.GRID_POOP, 0, p20.Room:GetGridPosition(index), true)
			end
			
		elseif subtype == p20SlipperyPoopSubType.CORNY then
		
			if p20ContentPack.GridSlipperyPoopCorny then
				p20ContentPack.GridSlipperyPoopCorny:Spawn(index, true, false)
			else
				Isaac.GridSpawn(GridEntityType.GRID_POOP, 2, p20.Room:GetGridPosition(index), true)
			end
			
		end
		
	end
	
	poopSpawnIndexes = {}
	
	for _, fakepoop in ipairs(Isaac.FindByType(EntityType.ENTITY_EFFECT, p20EffectVariant.SLIPPERY_POOP, p20SlipperyPoopSubType.NORMAL, false, false)) do
		fakepoop:Remove()
	end
	for _, fakepoop in ipairs(Isaac.FindByType(EntityType.ENTITY_EFFECT, p20EffectVariant.SLIPPERY_POOP, p20SlipperyPoopSubType.CORNY, false, false)) do
		fakepoop:Remove()
	end
end)

local function OnStageAPILoad()

	p20ContentPack.GridSlipperyPoop = StageAPI.CustomGrid("SlipperyPoop", GridEntityType.GRID_POOP, StageAPI.PoopVariant.Normal, "gfx/grid/piberpack/slippery_poop.anm2", "Appear", nil, nil, nil, true, 4)
	p20ContentPack.GridSlipperyPoopCorny = StageAPI.CustomGrid("SlipperyPoopCorny", GridEntityType.GRID_POOP, StageAPI.PoopVariant.Eternal, "gfx/grid/piberpack/slippery_poop_corny.anm2", "Appear", nil, nil, nil, true, 4)

	local function spawnSlipperyPoop(index, force, reSpawning, grid, persistData, gridData)
		if grid and p20.Room:GetFrameCount() < 2 then
			local sprite = grid.Sprite
			sprite:SetFrame("State" .. tostring(math.min(math.max(grid.State + 1,1),5)), 5)
			grid.Sprite = sprite
		end
	end
	StageAPI.AddCallback("p20ContentPack", "POST_SPAWN_CUSTOM_GRID", 1, spawnSlipperyPoop, "SlipperyPoop")
	StageAPI.AddCallback("p20ContentPack", "POST_SPAWN_CUSTOM_GRID", 1, spawnSlipperyPoop, "SlipperyPoopCorny")

	local function updateSlipperyPoop(grid, index, persistData, gridData, name)
		if grid and grid.State < 4 or not persistData.SpawnedDeathCreep then
			if p20.Room:HasWater() and Isaac.GetFrameCount()%5 == 0 or grid.State == 4 then
				
				local dontSpawnCreep = false
				if grid.State < 4 then
					for _, creep in ipairs(Isaac.FindByType(EntityType.ENTITY_EFFECT, EffectVariant.CREEP_SLIPPERY_BROWN, 0, true, false)) do
						creep = creep:ToEffect()
						if creep.Position:Distance(grid.Position) < 20 and creep.FrameCount <= 30 then
							dontSpawnCreep = true
							break
						end
					end
				end
				
				if not dontSpawnCreep then
					local creep = Isaac.Spawn(EntityType.ENTITY_EFFECT, EffectVariant.CREEP_SLIPPERY_BROWN, 0, grid.Position + Vector(0,8), p20.VECTOR_ZERO, nil):ToEffect()
					local scale = creep.Scale * 1.8
					creep.SpriteScale = Vector(scale, scale)
					creep:Update()
				end
				
				if grid.State == 4 then
					persistData.SpawnedDeathCreep = true
				end
				
			end
		end
	end
	StageAPI.AddCallback("p20ContentPack", "POST_CUSTOM_GRID_UPDATE", 1, updateSlipperyPoop, "SlipperyPoop")
	StageAPI.AddCallback("p20ContentPack", "POST_CUSTOM_GRID_UPDATE", 1, updateSlipperyPoop, "SlipperyPoopCorny")
	
end

if StageAPI and StageAPI.Loaded then
    OnStageAPILoad()
else
    if not StageAPI then
        StageAPI = {Loaded = false, ToCall = {}}
    end

    StageAPI.ToCall[#StageAPI.ToCall + 1] = OnStageAPILoad
end


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally