--debit card money hud
local DebitCardHud = Sprite()
DebitCardHud:Load("gfx/ui/p20_debit_card.anm2", true)
local DebitCardHudFont = Font()
DebitCardHudFont:Load("font/pftempestasevencondensed.fnt")
p20ContentPack:AddCallback(ModCallbacks.MC_POST_RENDER, function()
	if p20.SomeoneHasCard(p20Card.CARD_DEBIT) and p20.ModSave.Run.DebitCardSavedCoin and p20.ShouldRender() then
		--get variables we use for the hud
		local screenPos = p20.GetScreenTopLeft()
		local hudOffsetX = screenPos.X + 44
		local hudOffsetY = screenPos.Y + 32 --line it up with the coins
		if Isaac.GetPlayer(0):HasCollectible(CollectibleType.COLLECTIBLE_SCHOOLBAG) then --we intentionally get player 1 here because hud elements get in the way of the debit card hud when player 1 has the schoolbag
			hudOffsetY = hudOffsetY + 24 --move out of the way of the schoolbag and its item (now it's lined up with the keys)
		end
		if p20.ModSave.Run.DebitCardReachedDollar then
			hudOffsetX = hudOffsetX - 2
		end
		local hudOffsetTextX = hudOffsetX + 16
		local hudOffsetTextY = hudOffsetY + 1
		
		--debit card icon
		DebitCardHud:Play("Card", true)
		if p20.ModSave.Run.DebitCardReachedDollar then
			DebitCardHud:Render(Vector(hudOffsetX - 10, hudOffsetY + 1), p20.VECTOR_ZERO, p20.VECTOR_ZERO)
		else
			DebitCardHud:Render(Vector(hudOffsetX - 12, hudOffsetY + 1), p20.VECTOR_ZERO, p20.VECTOR_ZERO)
		end
		
		local debitCoins = p20.ModSave.Run.DebitCardCoins
		local coinText = tostring(debitCoins)
		--coin icon
		if p20.ModSave.Run.DebitCardReachedDollar then
			DebitCardHud:Play("Dollar", true)
			local dollars = debitCoins * 0.01
			if (dollars * 10) == math.floor(dollars * 10) then
				coinText = tostring(dollars) .. "0"
			else
				coinText = tostring(dollars)
			end
		else
			DebitCardHud:Play("Coin", true)
			if debitCoins < 10 then
				coinText = "0" .. tostring(debitCoins)
			end
		end
		DebitCardHud:Render(Vector(hudOffsetX,hudOffsetY), p20.VECTOR_ZERO, p20.VECTOR_ZERO)
		DebitCardHudFont:DrawString(coinText, hudOffsetTextX, hudOffsetTextY, p20.KCOLOR_DEFAULT, 0, false)
	end
end)

--separate coin entity that wont get morphed
local altCoinData = p20.GetPickupData(PickupVariant.PICKUP_COIN, CoinSubType.COIN_PENNY)
p20.SetPickupData(p20PickupVariant.PICKUP_COIN_ALT, p20CoinAltSubType.COIN_PENNY_ALT, altCoinData)

--card use effect
p20ContentPackDebitCardCoins = {
	[PickupVariant.PICKUP_COIN] = {
		[CoinSubType.COIN_STICKYNICKEL] = {
			AddCoins = 0,
			ForceAllowDebitPickup = true,
			CollectSound = SoundEffect.SOUND_NICKELDROP,
			DebitCardNoRemove = true,
			DebitCardCollectFunction = function(player, pickup)
				pickup:GetSprite():Play("Touched", false) --you cant pick up sticky nickels with the debit card
			end
		}
	},
	[PickupVariant.PICKUP_COLLECTIBLE] = {
		[CollectibleType.COLLECTIBLE_DOLLAR] = {
			AddCoins = 100,
			CollectSound = SoundEffect.SOUND_BOOK_PAGE_TURN_12,
			DebitCardNoCollect = true,
			DebitCardCollectFunction = function(player, pickup)
				p20.Streak("A Dollar")
				p20.AnimateHappyAll()
			end
		},
		[CollectibleType.COLLECTIBLE_QUARTER] = {
			AddCoins = 25,
			CollectSound = SoundEffect.SOUND_NICKELPICKUP,
			DebitCardNoCollect = true,
			DebitCardCollectFunction = function(player, pickup)
				p20.Streak("A Quarter")
				p20.AnimateHappyAll()
			end
		}
	}
}

p20.AddCustomCallback(p20ContentPack, p20Callbacks.MC_POST_USE_CARD, function(_, player, cardID, cardRNG, isTarotClothUse)
	p20.ModSave.Run.DebitCardSeen = true
	
	local data = p20ContentPack.GetData(player)
	local currentPlayer = p20.GetCurrentPlayer(player)
	
	--check every pickup to see if its a coin
	local maxCoinDistance = 70
	local coinsExist = false
	for _, pickup in pairs(Isaac.FindByType(EntityType.ENTITY_PICKUP, -1, -1, false, false)) do
		pickup = pickup:ToPickup()
		local pickupData = p20.GetPickupData(pickup.Variant, pickup.SubType)
		if p20ContentPackDebitCardCoins[pickup.Variant] and p20ContentPackDebitCardCoins[pickup.Variant][pickup.SubType] then
			pickupData = p20ContentPackDebitCardCoins[pickup.Variant][pickup.SubType]
		end
		if pickupData and ((pickupData.AddCoins and pickupData.AddCoins > 0) or pickupData.ForceAllowDebitPickup) then
			coinsExist = true
			if p20.IsPickupPickupable(pickup, false) and pickup.Position:Distance(player.Position) < maxCoinDistance then
			
				--remove the coin
				if not pickupData.DebitCardNoCollect and not pickupData.DebitCardNoRemove then
					p20.CollectPickup(pickup)
				elseif not pickupData.DebitCardNoRemove then
					pickup:Remove()
				end
				
				--play collect sound
				if pickupData.CollectSound then
					p20.SFX:Play(pickupData.CollectSound, 1.0, 1, false, 1)
				end
				
				--add coins
				if pickupData.AddCoins and pickupData.AddCoins ~= 0 then
					p20.ModSave.Run.DebitCardCoins = p20.ModSave.Run.DebitCardCoins + pickupData.AddCoins
				end
				
				--add luck
				if pickupData.AddLuck and pickupData.AddLuck ~= 0 then
					p20.ModSave.Run.PickupLuck[currentPlayer] = p20.ModSave.Run.PickupLuck[currentPlayer] + pickupData.AddLuck
					
					if pickup.Variant == PickupVariant.PICKUP_COIN and pickup.SubType == CoinSubType.COIN_LUCKYPENNY and p20RebalancePack and p20.ModSave.Config.Rebalance_LuckyPennies_ReduceLuck then
						p20.ModSave.Run.PickupLuck[currentPlayer] = p20.ModSave.Run.PickupLuck[currentPlayer] - 0.5
					end
					
					player:AddCacheFlags(CacheFlag.CACHE_LUCK)
					player:EvaluateItems()
					
					if pickupData.AddLuck > 0 then
						p20.Streak("Luck Up")
						player:AnimateHappy()
					else
						p20.Streak("Luck Down")
						player:AnimateSad()
					end
				end
				if pickupData.DebitCardCollectFunction and pickupData.DebitCardCollectFunction ~= 0 then
					pickupData.DebitCardCollectFunction(player, pickup)
				end
				
				--reveal the hud
				if p20.ModSave.Run.DebitCardCoins > 0 then
					p20.ModSave.Run.DebitCardSavedCoin = true
					
					--change coin icon to dollar sign if they have over 99 coins saved
					if p20.ModSave.Run.DebitCardCoins > 99 and not p20.ModSave.Run.DebitCardReachedDollar then
						p20.ModSave.Run.DebitCardReachedDollar = true
						p20.Streak("You have saved a dollar!")
						player:AnimateHappy()
					end
				end
			end
		end
	end
	
	if not coinsExist then --spawn one of our alternate coins if no coins were found
		local maxCoins = p20.GetPickupValues(PickupVariant.PICKUP_COIN, CoinSubType.COIN_PENNY)
		local debitCoins = p20.ModSave.Run.DebitCardCoins
		local coinsToSpawn = {}
		local removeCoins = 0
		for i=1, 3 do
			if debitCoins >= 1 then
				coinsToSpawn[i] = p20CoinAltSubType.COIN_PENNY_ALT
				removeCoins = removeCoins + 1
				debitCoins = debitCoins - 1
			end
		end
		
		local removeCoinsPlayer = math.ceil(removeCoins/3)
		if player:GetNumCoins() >= removeCoinsPlayer or not p20.ModSave.Config.Content_DebitCard_RemoveCoin then
			p20.ModSave.Run.DebitCardCoins = p20.ModSave.Run.DebitCardCoins - removeCoins
			if p20.ModSave.Config.Content_DebitCard_RemoveCoin then
				player:AddCoins(-removeCoinsPlayer)
			end
			for i=1, #coinsToSpawn do
				if coinsToSpawn[i] then
					Isaac.Spawn(EntityType.ENTITY_PICKUP, p20PickupVariant.PICKUP_COIN_ALT, coinsToSpawn[i], p20.Room:FindFreePickupSpawnPosition(player.Position,0,true), p20.VECTOR_ZERO, player)
				end
			end
		end
	end
	
	--give the card back
	if player:GetCard(0) ~= p20Card.CARD_DEBIT then
		player:AddCard(p20Card.CARD_DEBIT)
	end
end, p20Card.CARD_DEBIT)

p20ContentPack:AddCallback(ModCallbacks.MC_GET_CARD, function(_, rng, cardID, broken, isRune, onlyRunes)
	--the debit card should only appear in the run once
	if not p20.ModSave.Run.DebitCardSeen then
		--we dont want to replace runes or certain special cards
		if not p20.IsRune(cardID)
		and not p20.IsDiceShard(cardID)
		and not p20.IsHolyCard(cardID)
		and not p20.IsMagicCard(cardID)
		and cardID ~= Card.CARD_SUICIDE_KING
		and cardID ~= Card.CARD_GET_OUT_OF_JAIL
		and cardID ~= Card.CARD_QUESTIONMARK
		and cardID ~= Card.CARD_EMERGENCY_CONTACT then
			
			local replaceCardRNG = nil
			if currentCard == Card.CARD_CREDIT then --1/2 chance to replace credit card
				replaceCardRNG = p20.GetRandomNumber(1, 2, rng)
			else --1/50 chance to replace any other card (that we didnt skip above)
				replaceCardRNG = p20.GetRandomNumber(1, 50, rng)
			end --remember - the debit card will only appear once in the entire run
			
			--replace the card
			if replaceCardRNG == 1 then
				p20.ModSave.Run.DebitCardSeen = true
				return p20Card.CARD_DEBIT
			end
		end
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_PLAYER_UPDATE, function(_, player)
	if player:GetNumCoins() >= 99 and not p20.ModSave.Unlocks.ContentPack_DebitCard then
		p20.ModSave.Unlocks.ContentPack_DebitCard = true
		p20.DoAchievement("gfx/ui/achievement/piberpack/debit_card.png")
		p20.Save()
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_PICKUP_INIT, function(_, pickup)
	if pickup.SubType == p20Card.CARD_DEBIT then
		if not p20.ModSave.Unlocks.ContentPack_DebitCard then
			pickup:Morph(pickup.Type, pickup.Variant, Card.CARD_CREDIT, true)
		else
			local animation = "Idle"
			if p20.ShouldPickupPlayAppearAnimation(pickup) then
				animation = "Appear"
			end
			local sprite = pickup:GetSprite()
			sprite:Load("gfx/items/pick ups/piberpack/cards/debit_card.anm2", true)
			sprite:Play(animation, true)
		end
	end
end, PickupVariant.PICKUP_TAROTCARD)

p20.AddModInitFunction(InfinityTrueCoopInterface, __infinityTrueCoop, function()
	InfinityTrueCoopInterface.AddModdedCardFront(p20Card.CARD_DEBIT, "gfx/truecoop/cards/piberpack.anm2", "DebitCard")
end)

__eidCardDescriptions[p20Card.CARD_DEBIT] = "Reusable CardEnables storage of an infinite amount of coins#When used in a room with coins, the closest coin is added to the coin inventory#When used in a room without coins, a coins is dropped from its inventory, at the cost of another coin"


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally