p20.AddCustomCallback(p20ContentPack, p20Callbacks.MC_POST_USE_CARD, function(_, player, cardID, cardRNG, isTarotClothUse)
	player:AddBombs(5)
end, p20Card.CARD_CLUBS_5)

p20.AddCustomCallback(p20ContentPack, p20Callbacks.MC_POST_USE_CARD, function(_, player, cardID, cardRNG, isTarotClothUse)
	player:AddCoins(5)
end, p20Card.CARD_DIAMONDS_5)

p20.AddCustomCallback(p20ContentPack, p20Callbacks.MC_POST_USE_CARD, function(_, player, cardID, cardRNG, isTarotClothUse)
	player:AddKeys(5)
end, p20Card.CARD_SPADES_5)

p20.AddCustomCallback(p20ContentPack, p20Callbacks.MC_POST_USE_CARD, function(_, player, cardID, cardRNG, isTarotClothUse)
	player:AddHearts(5)
end, p20Card.CARD_HEARTS_5)

local fivesPool = {
	p20Card.CARD_CLUBS_5,
	p20Card.CARD_DIAMONDS_5,
	p20Card.CARD_SPADES_5,
	p20Card.CARD_HEARTS_5
}
p20ContentPack:AddCallback(ModCallbacks.MC_GET_CARD, function(_, rng, cardID, broken, isRune, onlyRunes)
	if p20.IsPlayingCard(cardID, false) then
		local replaceCardRNG = p20.GetRandomNumber(1, 8, rng)
		if replaceCardRNG == 1 then
			return fivesPool[p20.GetRandomNumber(1, #fivesPool, rng)]
		end
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, function(_, isSaveGame)
	p20.AddPlayingCard(p20Card.CARD_CLUBS_5)
	p20.AddPlayingCard(p20Card.CARD_DIAMONDS_5)
	p20.AddPlayingCard(p20Card.CARD_SPADES_5)
	p20.AddPlayingCard(p20Card.CARD_HEARTS_5)
end)

p20.AddModInitFunction(InfinityTrueCoopInterface, __infinityTrueCoop, function()
	InfinityTrueCoopInterface.AddModdedCardFront(p20Card.CARD_CLUBS_5, "gfx/truecoop/cards/piberpack.anm2", "5OfClubs")
	InfinityTrueCoopInterface.AddModdedCardFront(p20Card.CARD_DIAMONDS_5, "gfx/truecoop/cards/piberpack.anm2", "5OfHearts")
	InfinityTrueCoopInterface.AddModdedCardFront(p20Card.CARD_SPADES_5, "gfx/truecoop/cards/piberpack.anm2", "5OfSpades")
	InfinityTrueCoopInterface.AddModdedCardFront(p20Card.CARD_HEARTS_5, "gfx/truecoop/cards/piberpack.anm2", "5OfDiamonds")
end)

__eidCardDescriptions[p20Card.CARD_CLUBS_5] = "+5 Bombs"
__eidCardDescriptions[p20Card.CARD_DIAMONDS_5] = "+5 Coins"
__eidCardDescriptions[p20Card.CARD_SPADES_5] = "+5 Keys"
__eidCardDescriptions[p20Card.CARD_HEARTS_5] = "Heals 2 and a half heart containers"


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally