local batterySpawnRNG = p20.GetInitializedRNG()
p20ContentPack:AddCallback(ModCallbacks.MC_POST_NEW_ROOM, function()
	if p20.Room:IsFirstVisit() and not p20.Room:IsClear() and p20.SomeoneHasCollectible(p20CollectibleType.COLLECTIBLE_BATTERY_TESTER) then
		batterySpawnRNG:SetSeed(p20.Room:GetSpawnSeed(), 1)
		for i=1, p20.EveryoneHasCollectibleNum(p20CollectibleType.COLLECTIBLE_BATTERY_TESTER) do
			if p20.GetRandomNumber(1, 100, batterySpawnRNG) <= 20 then
				Isaac.Spawn(EntityType.ENTITY_PICKUP, p20PickupVariant.PICKUP_BATTERY_ALT, p20BatteryAltSubType.BATTERY_LEAKY, p20.Room:FindFreePickupSpawnPosition(p20.Room:GetCenterPos(),0,true), p20.VECTOR_ZERO, nil)
			end
		end
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_UPDATE, function()
	if p20.ModSave.HitsFromLeakyBatteries >= 20 and not p20.ModSave.Unlocks.ContentPack_BatteryTester then
		p20.ModSave.Unlocks.ContentPack_BatteryTester = true
		p20.DoAchievement("gfx/ui/achievement/piberpack/battery_tester.png")
		p20.Save()
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_NEW_ROOM, function()
	if not p20.ModSave.Unlocks.ContentPack_BatteryTester then
		p20.ItemPool:RemoveCollectible(p20CollectibleType.COLLECTIBLE_BATTERY_TESTER)
	end
end)

__eidItemDescriptions[p20CollectibleType.COLLECTIBLE_BATTERY_TESTER] = "Small chance for a Leaky Battery to appear when first entering a room#Leaky Batteries deal damage to enemies based on your damage stat#Leaky Batteries are less likely to die#Dead Batteries charge your active item by 1"


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally