p20ContentPackSpecialBabies = {
	{
		Name = "Spider Baby",
		Spritesheet = "000_Baby_Spider.png",
		OnUpdate = function(baby, data, player)
			data.SpawnSpiderFrame = data.SpawnSpiderFrame or math.random(25,35)
			data.SpawnSpiderAmount = data.SpawnSpiderAmount or 3
			if data.SpawnSpiderAmount > 0 then
				if data.SpawnSpiderFrame <= 0 then
					if p20.GetRandomNumber(1, 100) <= 20 then
						player:ThrowBlueSpider(baby.Position, player.Position)
						data.SpawnSpiderAmount = data.SpawnSpiderAmount - 1
					end
					data.SpawnSpiderFrame = nil
				else
					data.SpawnSpiderFrame = data.SpawnSpiderFrame - 1
				end
			end
		end,
		OnNewRoom = function(baby, data, player)
			if p20.Room:IsFirstVisit() and not p20.Room:IsClear() then
				data.SpawnSpiderAmount = nil
			end
		end
	},
	{
		Name = "Love Baby",
		Spritesheet = "001_Baby_Love.png",
		OnPlayerDamaged = function(baby, data, player, amount, flags, source)
			if p20.GetPlayerFullHealth(player, true) < 4 then
				if p20.Room:IsFirstVisit() and not p20.Room:IsClear() then
					if p20.GetRandomNumber(1, 100) <= (50 - (Isaac.CountEntities(nil, EntityType.ENTITY_PICKUP, PickupVariant.PICKUP_HEART, -1)*25)) then
						Isaac.Spawn(EntityType.ENTITY_PICKUP, PickupVariant.PICKUP_HEART, 0, baby.Position, p20.VECTOR_ZERO, baby)
					end
				end
			end
		end
	},
	{
		Name = "Bloat Baby",
		Spritesheet = "002_Baby_Bloat.png",
		OnUpdate = function(baby, data, player)
			if not data.FlyOrbital or (data.FlyOrbital and not data.FlyOrbital:Exists()) then
				data.FlyOrbital = Isaac.Spawn(EntityType.ENTITY_FAMILIAR, p20FamiliarVariant.SPECIAL_BABY_FLY_ORBITAL, 0, baby.Position, p20.VECTOR_ZERO, baby):ToFamiliar()
			else
				local angle = data.FlyOrbital.FrameCount * 2
				local offset = Vector(0, 20):Rotated(angle)
				local targetPos = baby.Position + offset
				data.FlyOrbital.Velocity = targetPos - data.FlyOrbital.Position
				p20ContentPack.GetData(data.FlyOrbital).StayAlive = 10
			end
		end
	},
	{
		Name = "Water Baby",
		Spritesheet = "003_Baby_Water.png",
		OnPlayerDamaged = function(baby, data, player, amount, flags, source)
			if p20.GetPlayerFullHealth(player, true) < 4 then
				local projs = 8
				local shootVector = Vector(0,0.5)
				for i=1, projs do
					baby:FireProjectile(shootVector)
					shootVector = shootVector:Rotated(360/projs)
				end
			end
		end
	},
	{
		Name = "Psy Baby",
		Spritesheet = "004_Baby_Psy.png",
		TearFlags = TearFlags.TEAR_HOMING,
		TearColor = Color(0.375,0,0.5,1,75,0,100)
	},
	--[[
	{
		Name = "Cursed Baby",
		Spritesheet = "005_Baby_Cursed.png",
		IsBadBaby = true,
		OnUpdate = function(baby, data, player) --needs to pull enemies in like a gaping maw
			
		end
	},
	]]
	{
		Name = "Troll Baby",
		Spritesheet = "006_Baby_Troll.png",
		IsBadBaby = true,
		OnUpdate = function(baby, data, player)
			data.SpawnBombFrame = data.SpawnBombFrame or math.random(25,35)
			if data.SpawnBombFrame <= 0 then
				if p20.GetRandomNumber(1, 100) <= 20 then
					Isaac.Spawn(EntityType.ENTITY_PICKUP, PickupVariant.PICKUP_BOMB, BombSubType.BOMB_TROLL, baby.Position, p20.VECTOR_ZERO, baby)
				end
				data.SpawnBombFrame = nil
			else
				data.SpawnBombFrame = data.SpawnBombFrame - 1
			end
		end
	},
	{
		Name = "Ybab",
		Spritesheet = "007_Baby_Ybab.png",
		IsBadBaby = true,
		OnShoot = function(baby, data, player, tear)
			tear.Velocity = tear.Velocity:Rotated(math.random(0,360))
		end
	},
	{
		Name = "Cockeyed Baby",
		Spritesheet = "008_Baby_Cockeyed.png",
		IsBadBaby = true,
		OnShoot = function(baby, data, player, tear)
			local rotateBy = 45
			if data.CockeyeDiagTearTicker then
				rotateBy = -45
			end
			
			tear.Velocity = tear.Velocity:Rotated(rotateBy)
			
			data.CockeyeDiagTearTicker = not data.CockeyeDiagTearTicker
		end
	}
}

--[[
	<baby id="9" name="Host Baby" skin="009_Baby_Host.png" />
	<baby id="10" name="Lost Baby" skin="010_Baby_Lost.png" achievement="167" />
	<baby id="11" name="Cute Baby" skin="011_Baby_Cute.png" achievement="168" />
	<baby id="12" name="Crow Baby" skin="012_Baby_Crow.png" achievement="169" />
	<baby id="13" name="Shadow Baby" skin="013_Baby_Shadow.png" achievement="170" />
	<baby id="14" name="Glass Baby" skin="014_Baby_Glass.png" achievement="171" />
	<baby id="15" name="Gold Baby" skin="015_Baby_Gold.png" />
	<baby id="16" name="Cy-Baby" skin="016_Baby_Cy.png" />
	<baby id="17" name="Bean Baby" skin="017_Baby_Bean.png" />
	<baby id="18" name="Mag Baby" skin="018_Baby_Mag.png" />
	<baby id="19" name="Wrath Baby" skin="019_Baby_Wrath.png" />
	<baby id="20" name="Wrapped Baby" skin="020_Baby_Wrapped.png" achievement="172" />
	<baby id="21" name="Begotten Baby" skin="021_Baby_Begotten.png" achievement="173" />
	<baby id="22" name="Dead Baby" skin="022_Baby_Dead.png" achievement="174" />
	<baby id="23" name="Fighting Baby" skin="023_Baby_Fighting.png" achievement="177" />
	<baby id="24" name="-0-" skin="024_Baby_0.png" achievement="175" />
	<baby id="25" name="Glitch Baby" skin="025_Baby_Glitch.png" achievement="176" />
	<baby id="26" name="Magnet Baby" skin="026_Baby_Magnet.png" />
	<baby id="27" name="Black Baby" skin="027_Baby_Black.png" achievement="212" />
	<baby id="28" name="Red Baby" skin="028_Baby_Red.png" achievement="206" />
	<baby id="29" name="White Baby" skin="029_Baby_White.png" achievement="215" />
	<baby id="30" name="Blue Baby" skin="030_Baby_Blue.png" achievement="209" />
	<baby id="31" name="Rage Baby" skin="031_Baby_Rage.png" achievement="211" />
	<baby id="32" name="Cry Baby" skin="032_Baby_Cry.png" achievement="205" />
	<baby id="33" name="Yellow Baby" skin="033_Baby_Yellow.png" achievement="214" />
	<baby id="34" name="Long Baby" skin="034_Baby_Long.png" achievement="213" />
	<baby id="35" name="Green Baby" skin="035_Baby_Green.png" achievement="207" />
	<baby id="36" name="Lil' Baby" skin="036_Baby_Lil.png" achievement="210" />
	<baby id="37" name="Big Baby" skin="037_Baby_Big.png" achievement="216" />
	<baby id="38" name="Brown Baby" skin="038_Baby_Brown.png" achievement="208" />
	<baby id="39" name="Noose Baby" skin="039_Baby_Noose.png" achievement="217" />
	<baby id="40" name="Hive Baby" skin="040_Baby_Hive.png" achievement="252" />
	<baby id="41" name="Buddy Baby" skin="041_Baby_Buddy.png" achievement="253" />
	<baby id="42" name="Colorful Baby" skin="042_Baby_Colorful.png" achievement="254" />
	<baby id="43" name="Whore Baby" skin="043_Baby_Whore.png" achievement="255" />
	<baby id="44" name="Cracked Baby" skin="044_Baby_Cracked.png" achievement="256" />
	<baby id="45" name="Dripping Baby" skin="045_Baby_Dripping.png" achievement="257" />
	<baby id="46" name="Blinding Baby" skin="046_Baby_Blinding.png" achievement="258" />
	<baby id="47" name="Sucky Baby" skin="047_Baby_Sucky.png" achievement="259" />
	<baby id="48" name="Dark Baby" skin="048_Baby_Dark.png" achievement="260" />
	<baby id="49" name="Picky Baby" skin="049_Baby_Picky.png" achievement="261" />
	<baby id="50" name="Revenge Baby" skin="050_Baby_Revenge.png" achievement="262" />
	<baby id="51" name="Belial Baby" skin="051_Baby_Belial.png" achievement="263" />
	<baby id="52" name="Sale Baby" skin="052_Baby_Sale.png" achievement="264" />
	<baby id="53" name="Goat Head Baby" skin="053_Baby_GoatBaby.png" achievement="223" />
	<baby id="54" name="Super Greed Baby" skin="054_Baby_Super GreedBaby.png" achievement="241" />
	<baby id="55" name="Mort Baby" skin="055_Baby_Mort.png" achievement="317" />
	<baby id="56" name="Apollyon Baby" skin="056_Baby_Apollyon.png" achievement="319" />
	<baby id="57" name="Bone Baby" skin="057_Baby_Boner.png" achievement="402" />
	<baby id="58" name="Bound Baby" skin="058_Baby_Bound.png" achievement="403" />
]]

p20ContentPackBasicBabies = {
	"059_Baby_Bigeyes.png",
	"060_Baby_Sleep.png",
	"061_Baby_Zombie.png",
	"062_Baby_Goat.png",
	"063_Baby_Butthole.png",
	"064_Baby_Eyepatch.png",
	"064_Baby_Eyepatch.png",
	"065_Baby_Bloodeyes.png",
	"066_Baby_Mustache.png",
	"067_Baby_Spittle.png",
	"068_Baby_Brain.png",
	"069_Baby_ThreeEyes.png",
	"070_Baby_Viridian.png",
	"071_Baby_Blockhead.png",
	"072_Baby_Worm.png",
	"073_Baby_Lowface.png",
	"074_Baby_AlienHominid.png",
	"075_Baby_Bomb.png",
	"076_Baby_Video.png",
	"077_Baby_Parasite.png",
	"078_Baby_Derp.png",
	"079_Baby_Lobotomy.png",
	"080_Baby_Choke.png",
	"081_Baby_Scream.png",
	"082_Baby_Gurdy.png",
	"083_Baby_Ghoul.png",
	"084_Baby_Goatee.png",
	"085_Baby_Shades.png",
	"086_Baby_Statue.png",
	"087_Baby_Bloodsucker.png",
	"088_Baby_Bandaid.png",
	"089_Baby_Eyebrows.png",
	"090_Baby_Nerd.png",
	"091_Baby_Boss.png",
	"092_Baby_Turd.png",
	"093_Baby_O.png",
	"094_Baby_SquareEyes.png",
	"095_Baby_Teeth.png",
	"096_Baby_Frown.png",
	"097_Baby_Tongue.png",
	"098_Baby_HalfHead.png",
	"099_Baby_Makeup.png",
	"100_Baby_Ed.png",
	"101_Baby_D.png",
	"102_Baby_Guppy.png",
	"103_Baby_Puke.png",
	"104_Baby_Dumb.png",
	"105_Baby_Lipstick.png",
	"106_Baby_Aether.png",
	"107_Baby_Brownie.png",
	"108_Baby_VVVVVV.png",
	"109_Baby_Nosferatu.png",
	"110_Baby_Pubic.png",
	"111_Baby_Eyemouth.png",
	"112_Baby_Weirdo.png",
	"113_Baby_V.png",
	"114_Baby_StrangeMouth.png",
	"115_Baby_Masked.png",
	"116_Baby_Cyber.png",
	"117_Baby_AxeWound.png",
	"118_Baby_Statue.png",
	"119_Baby_Grin.png",
	"120_Baby_Upset.png",
	"121_Baby_Plastic.png",
	"122_Baby_Monochrome.png",
	"123_Baby_OneTooth.png",
	"124_Baby_Tusks.png",
	"125_Baby_Hopeless.png",
	"126_Baby_BigMouth.png",
	"127_Baby_PeeEyes.png",
	"128_Baby_Earwig.png",
	"129_Baby_Ninkumpoop.png",
	"130_Baby_StrangeShape.png",
	"131_Baby_Bugeyed.png",
	"132_Baby_Freaky.png",
	"133_Baby_Crooked.png",
	"134_Baby_SpiderLegs.png",
	"135_Baby_Smiling.png",
	"136_Baby_Tears.png",
	"137_Baby_Bowling.png",
	"138_Baby_Mohawk.png",
	"139_Baby_RottenMeat.png",
	"140_Baby_NoArms.png",
	"141_Baby_Twin2.png",
	"142_Baby_UglyGirl.png",
	"143_Baby_Chompers.png",
	"144_Baby_CamilloJr.png",
	"145_Baby_Eyeless.png",
	"146_Baby_Sloppy.png",
	"147_Baby_Bluebird.png",
	"148_Baby_Fat.png",
	"149_Baby_Butterfly.png",
	"150_Baby_Goggles.png",
	"151_Baby_Apathetic.png",
	"152_Baby_Cape.png",
	"153_Baby_Sorrow.png",
	"154_Baby_Rictus.png",
	"155_Baby_Awaken.png",
	"156_Baby_Puff.png",
	"157_Baby_Attractive.png",
	"158_Baby_Pretty.png",
	"159_Baby_CrackedInfamy.png",
	"160_Baby_Distended.png",
	"161_Baby_Mean.png",
	"162_Baby_Digital.png",
	"163_Baby_Helmet.png",
	"164_Baby_BlackEye.png",
	"165_Baby_Lights.png",
	"166_Baby_Spike.png",
	"167_Baby_Worry.png",
	"168_Baby_Ears.png",
	"169_Baby_Funeral.png",
	"170_Baby_Libra.png",
	"171_Baby_Gappy.png",
	"172_Baby_Sunburn.png",
	"173_Baby_AtePoop.png",
	"174_Baby_Electris.png",
	"175_Baby_BloodHole.png",
	"176_Baby_Transforming.png",
	"177_Baby_Aban.png",
	"178_Baby_BandageGirl.png",
	"179_Baby_PieceA.png",
	"180_Baby_PieceB.png",
	"181_Baby_Spelunker.png",
	"182_Baby_Frog.png",
	"183_Baby_Crook.png",
	"184_Baby_Don.png",
	"185_Baby_Web.png",
	"186_Baby_Faded.png",
	"187_Baby_Sick.png",
	"188_Baby_DrFetus.png",
	"189_Baby_Spectral.png",
	"190_Baby_RedSkeleton.png",
	"191_Baby_Skeleton.png",
	"192_Baby_Jammies.png",
	"193_Baby_NewJammies.png",
	"194_Baby_Cold.png",
	"195_Baby_OldMan.png",
	"196_Baby_Spooked.png",
	"197_Baby_Nice.png",
	"198_Baby_Dots.png",
	"199_Baby_Peeling.png",
	"200_Baby_SmallFace.png",
	"201_Baby_Good.png",
	"202_Baby_Blindfold.png",
	"203_Baby_Pipe.png",
	"204_Baby_Dented.png",
	"205_Baby_Steven.png",
	"206_Baby_Monocle.png",
	"207_Baby_Belial.png",
	"208_Baby_Monstro.png",
	"209_Baby_Fez.png",
	"210_Baby_Meatboy.png",
	"211_Baby_Skull.png",
	"212_Baby_Conjoined.png",
	"213_Baby_Skinny.png",
	"214_Baby_Spider.png",
	"215_Baby_Shopkeeper.png",
	"216_Baby_Fancy.png",
	"217_Baby_Chubby.png",
	"218_Baby_Cyclops.png",
	"219_Baby_Isaac.png",
	"220_Baby_Plug.png",
	"221_Baby_Drool.png",
	"222_Baby_Wink.png",
	"223_Baby_Pox.png",
	"224_Baby_Onion.png",
	"225_Baby_Zipper.png",
	"226_Baby_Buckteeth.png",
	"227_Baby_Beard.png",
	"228_Baby_Hanger.png",
	"229_Baby_Vampire.png",
	"230_Baby_Tilt.png",
	"231_Baby_Bawl.png",
	"232_Baby_Lemon.png",
	"233_baby_punkboy.png",
	"234_baby_punkgirl.png",
	"235_baby_computer.png",
	"236_baby_mask.png",
	"237_baby_gem.png",
	"238_baby_shark.png",
	"239_baby_beret.png",
	"240_baby_blisters.png",
	"241_baby_radioactive.png",
	"242_baby_beast.png",
	"243_baby_dark.png",
	"244_baby_snail.png",
	"245_baby_blood.png",
	"246_baby_8ball.png",
	"247_baby_wisp.png",
	"248_baby_cactus.png",
	"249_baby_loveeye.png",
	"250_baby_medusa.png",
	"251_baby_nuclear.png",
	"252_baby_purple.png",
	"253_baby_wizard.png",
	"254_baby_earth.png",
	"255_baby_saturn.png",
	"256_baby_cloud.png",
	"257_baby_tube.png",
	"258_baby_rocker.png",
	"259_baby_king.png",
	"260_baby_coat.png",
	"261_baby_viking.png",
	"262_baby_panda.png",
	"263_baby_raccoon.png",
	"264_baby_bear.png",
	"265_baby_polarbear.png",
	"266_baby_lovebear.png",
	"267_baby_hare.png",
	"268_baby_squirrel.png",
	"269_baby_tabby.png",
	"270_baby_porcupine.png",
	"271_baby_puppy.png",
	"272_baby_parrot.png",
	"273_baby_chameleon.png",
	"274_baby_boulder.png",
	"275_baby_aqua.png",
	"276_baby_gargoyle.png",
	"277_baby_spikydemon.png",
	"278_baby_reddemon.png",
	"279_baby_orangedemon.png",
	"280_baby_eyedemon.png",
	"281_baby_fangdemon.png",
	"282_baby_ghost.png",
	"283_baby_arachnid.png",
	"284_baby_bony.png",
	"285_baby_bigtongue.png",
	"286_baby_3D.png",
	"287_baby_suit.png",
	"288_baby_butt.png",
	"289_baby_cupid.png",
	"290_baby_heart.png",
	"291_baby_killer.png",
	"292_baby_lantern.png",
	"293_baby_banshee.png",
	"294_baby_ranger.png",
	"295_baby_rider.png",
	"296_baby_choco.png",
	"297_baby_woodsman.png",
	"298_baby_brunette.png",
	"299_baby_blonde.png",
	"300_baby_bluehair.png",
	"301_baby_bloodied.png",
	"302_baby_cheese.png",
	"303_baby_pizza.png",
	"304_baby_hotdog.png",
	"305_baby_pear.png",
	"306_baby_borg.png",
	"307_baby_corrupted.png",
	"308_baby_Xmouth.png",
	"309_baby_Xeyes.png",
	"310_baby_stareyes.png",
	"311_baby_surgeon.png",
	"312_baby_sword.png",
	"313_baby_monk.png",
	"314_baby_disco.png",
	"315_baby_puzzle.png",
	"316_baby_speaker.png",
	"317_baby_scary.png",
	"318_baby_fireball.png",
	"319_baby_maw.png",
	"320_baby_exploding.png",
	"321_baby_cupcake.png",
	"322_baby_skinless.png",
	"323_baby_ballerina.png",
	"324_baby_goblin.png",
	"325_baby_coolgoblin.png",
	"326_baby_geek.png",
	"327_baby_longbeard.png",
	"328_baby_muttonchops.png",
	"329_baby_spartan.png",
	"330_baby_tortoise.png",
	"331_baby_slicer.png",
	"332_baby_butterfly.png",
	"333_baby_homeless.png",
	"334_baby_lumberjack.png",
	"335_baby_cyberspace.png",
	"336_baby_hero.png",
	"337_baby_boxers.png",
	"338_baby_winghelmet.png",
	"339_baby_X.png",
	"340_baby_O.png",
	"341_baby_vomit.png",
	"342_baby_merman.png",
	"343_baby_cyborg.png",
	"344_baby_barbarian.png",
	"345_baby_locust.png",
	"346_baby_twotone.png",
	"347_baby_2600.png",
	"348_baby_fourtone.png",
	"349_baby_grayscale.png",
	"350_baby_rabbit.png",
	"351_baby_mouse.png",
	"352_baby_critter.png",
	"353_baby_bluerobot.png",
	"354_baby_pilot.png",
	"355_baby_redplumber.png",
	"356_baby_greenplumber.png",
	"357_baby_yellowplumber.png",
	"358_baby_purpleplumber.png",
	"359_baby_tanooki.png",
	"360_baby_mushroomman.png",
	"361_baby_mushroomgirl.png",
	"362_baby_cannonball.png",
	"363_baby_froggy.png",
	"364_baby_turtledragon.png",
	"365_baby_shellsuit.png",
	"366_baby_fiery.png",
	"367_baby_meanmushroom.png",
	"368_baby_arcade.png",
	"369_baby_scaredghost.png",
	"370_baby_blueghost.png",
	"371_baby_redghost.png",
	"372_baby_pinkghost.png",
	"373_baby_orangeghost.png",
	"374_baby_pinkprincess.png",
	"375_baby_yellowprincess.png",
	"376_baby_dino.png",
	"377_baby_elf.png",
	"378_baby_darkelf.png",
	"379_baby_darkknight.png",
	"380_baby_octopus.png",
	"381_baby_orangepig.png",
	"382_baby_bluepig.png",
	"383_baby_elfprincess.png",
	"384_baby_fishman.png",
	"385_baby_fairyman.png",
	"386_baby_imp.png",
	"387_baby_worm.png",
	"388_baby_bluewrestler.png",
	"389_baby_redwrestler.png",
	"390_baby_toast.png",
	"391_baby_roboboy.png",
	"392_baby_liberty.png",
	"393_baby_dreamknight.png",
	"394_baby_cowboy.png",
	"395_baby_mermaid.png",
	"396_baby_plague.png",
	"397_baby_spacesoldier.png",
	"398_baby_darkspacesoldier.png",
	"399_baby_gasmask.png",
	"400_baby_tomboy.png",
	"401_baby_corgi.png",
	"402_baby_unicorn.png",
	"403_baby_pixie.png",
	"404_baby_referee.png",
	"405_baby_dealwithit.png",
	"406_baby_astronaut.png",
	"407_baby_blurred.png",
	"408_baby_censored.png",
	"409_baby_coolghost.png",
	"410_baby_gills.png",
	"411_baby_bluehat.png",
	"412_baby_catsuit.png",
	"413_baby_pirate.png",
	"414_baby_superrobo.png",
	"415_baby_lightmage.png",
	"416_baby_puncher.png",
	"417_baby_holyknight.png",
	"418_baby_shadowmage.png",
	"419_baby_firemage.png",
	"420_baby_priest.png",
	"421_baby_zipper.png",
	"422_baby_bag.png",
	"423_baby_sailor.png",
	"424_baby_rich.png",
	"425_baby_toga.png",
	"426_baby_knight.png",
	"427_baby_blackknight.png",
	"428_baby_magiccat.png",
	"429_baby_littlehorn.png",
	"430_baby_folder.png",
	"431_baby_driver.png",
	"432_baby_dragon.png",
	"433_baby_downwell.png",
	"434_baby_cylinder.png",
	"435_baby_cup.png",
	"436_baby_cave_robot.png",
	"437_baby_breadmeat_hoodiebread.png",
	"438_baby_bigmouth.png",
	"439_baby_afro_rainbow.png",
	"440_baby_afro.png",
	"441_baby_tv.png",
	"442_baby_tooth.png",
	"443_baby_tired.png",
	"444_baby_steroids.png",
	"445_baby_soap_monster.png",
	"446_baby_rojen_whitefox.png",
	"447_baby_rocket.png",
	"448_baby_nurf.png",
	"449_baby_mutated_fish.png",
	"450_baby_moth.png",
	"451_baby_buttface.png",
	"452_baby_flying_candle.png",
	"453_baby_graven.png",
	"454_baby_gizzy_chargeshot.png",
	"455_baby_green_koopa.png",
	"456_baby_handsome_mrfrog.png",
	"457_baby_pumpkin_guy.png",
	"458_baby_red_koopa.png",
	"459_baby_sad_bunny.png",
	"460_baby_saturn.png",
	"461_baby_toast_boy.png",
	"462_baby_voxdog.png",
	"463_baby_404.png",
	"464_baby_arrowhead.png",
	"465_baby_beanie.png",
	"466_baby_blindcursed.png",
	"467_baby_burning.png",
	"468_baby_cursor.png",
	"469_baby_flybaby.png",
	"470_baby_headphone.png",
	"471_baby_knife.png",
	"472_baby_mufflerscarf.png",
	"473_baby_robbermask.png",
	"474_baby_scoreboard.png",
	"475_baby_somanyeyes.png",
	"476_baby_text.png",
	"477_baby_wing.png",
	"478_Baby_Tooth.png",
	"479_Baby_Haunt.png",
	"480_Baby_Imp.png",
	"481_Baby_32Bit.png",
	"482_Baby_Adventure.png",
	"483_Baby_Bubbles.png",
	"484_Baby_Bulb.png",
	"485_Baby_CoolOrange.png",
	"486_Baby_CrazyGhost.png",
	"487_Baby_CursedPillow.png",
	"488_Baby_Egg.png",
	"489_Baby_Factory.png",
	"490_Baby_Falling.png",
	"491_Baby_Funny.png",
	"492_Baby_Gamer.png",
	"493_Baby_GlitteryPeach.png",
	"494_Baby_Pompadour.png",
	"495_Baby_HeadKick.png",
	"496_Baby_Horn.png",
	"497_Baby_Ichor.png",
	"498_Baby_Ill.png",
	"499_Baby_Lazy.png",
	"500_Baby_Mern.png",
	"501_Baby_Necro.png",
	"502_Baby_Peeping.png",
	"503_Baby_Penance.png",
	"504_Baby_Psychic.png",
	"505_Baby_Puppet.png",
	"506_Baby_Reaper.png",
	"507_Baby_Roadkill.png",
	"508_Baby_SausageLover.png",
	"509_Baby_Scribble.png",
	"510_Baby_StarPlant.png",
	"511_Baby_Twitchy.png",
	"512_Baby_Witch.png",
	"513_Baby_Workshop.png",
	"514_Baby_Hooligan.png",
	"515_Baby_HalfSpider.png",
	"516_Baby_Silly.png",
	"517_Baby_MasterCook.png",
	"518_Baby_GreenPepper.png",
	"519_Baby_BaggyCap.png",
	"520_Baby_Stylish.png"
}

p20ContentPackDrippingBabies = {
	["003_Baby_Water.png"] = true,
	["010_Baby_Lost.png"] = true,
	["045_Baby_Dripping.png"] = true,
	["050_Baby_Revenge.png"] = true,
	["058_Baby_Bound.png"] = true
}

local babyToForce = nil
p20ContentPack:AddCallback(ModCallbacks.MC_EXECUTE_CMD, function(_, command, args)
	local commandFunction = {
		["forcespecialbaby"] = function(args)
			babyToForce = nil
			if tonumber(args) then
				args = math.floor(tonumber(args))
				if p20ContentPackSpecialBabies[args] then
					babyToForce = args
				end
			end
		end
	}
	command = command:lower()
	if commandFunction[command] then
		commandFunction[command](args)
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_EVALUATE_CACHE, function(_, player, cacheFlag)
	if cacheFlag == CacheFlag.CACHE_FAMILIARS then
		--special babies
		local num = player:GetCollectibleNum(p20CollectibleType.COLLECTIBLE_SPECIAL_BABIES)
		if num > 0 then
			num = num + player:GetEffects():GetCollectibleEffectNum(CollectibleType.COLLECTIBLE_BOX_OF_FRIENDS)
		end
		local rng = RNG()
		rng:SetSeed(math.random(10000), 0)
		player:CheckFamiliar(p20FamiliarVariant.SPECIAL_BABY, num, rng)
		
		--reimplemented buddy in a box
		local num = player:GetCollectibleNum(p20CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX)
		if num > 0 then
			num = num + player:GetEffects():GetCollectibleEffectNum(CollectibleType.COLLECTIBLE_BOX_OF_FRIENDS)
		end
		local rng = RNG()
		rng:SetSeed(math.random(10000), 0)
		player:CheckFamiliar(p20FamiliarVariant.BASIC_BABY, num, rng)
	end
end)

local floatAnimations = {
	[Direction.LEFT] = "FloatLeft",
	[Direction.UP] = "FloatUp",
	[Direction.RIGHT] = "FloatRight",
	[Direction.DOWN] = "FloatDown"
}
local shootAnimations = {
	[Direction.LEFT] = "FloatShootLeft",
	[Direction.UP] = "FloatShootUp",
	[Direction.RIGHT] = "FloatShootRight",
	[Direction.DOWN] = "FloatShootDown"
}
local shootVectors = {
	[Direction.LEFT] = p20.VECTOR_LEFT,
	[Direction.UP] = p20.VECTOR_UP,
	[Direction.RIGHT] = p20.VECTOR_RIGHT,
	[Direction.DOWN] = p20.VECTOR_DOWN
}

local function specialBabyAI(_, baby)
	local sprite, data, player = baby:GetSprite(), p20ContentPack.GetData(baby), baby.Player
	
	if not data.Init then
		data.LastStage = p20.Level:GetStage()
		data.LastStageType = p20.Level:GetStageType()
		data.Init = true
	end
	
	if data.LastStage ~= p20.Level:GetStage() or data.LastStageType ~= p20.Level:GetStageType() then
		data.LastStage = p20.Level:GetStage()
		data.LastStageType = p20.Level:GetStageType()
		baby.SubType = 0
	end
	
	if baby.Variant == p20FamiliarVariant.SPECIAL_BABY
	and p20ContentPackSpecialBabies[baby.SubType]
	and p20ContentPackSpecialBabies[baby.SubType].IsBadBaby
	and player:HasCollectible(CollectibleType.COLLECTIBLE_BFFS) then
		baby.SubType = 0
	end
	
	if not data.babyID or baby.SubType <= 0 or data.babyID ~= baby.SubType then
		if baby.Variant == p20FamiliarVariant.SPECIAL_BABY and babyToForce and p20ContentPackSpecialBabies[babyToForce] then
			baby.SubType = babyToForce
			data.babyID = babyToForce
			data.babyData = p20ContentPackSpecialBabies[babyToForce]
		elseif baby.Variant == p20FamiliarVariant.SPECIAL_BABY and baby.SubType > 0 and p20ContentPackSpecialBabies[baby.SubType] then
			data.babyID = baby.SubType
			data.babyData = p20ContentPackSpecialBabies[baby.SubType]
		elseif baby.Variant == p20FamiliarVariant.BASIC_BABY and baby.SubType > 0 and p20ContentPackBasicBabies[baby.SubType] then
			data.babyID = baby.SubType
			data.babyData = {
				Name = "Basic Baby",
				Spritesheet = p20ContentPackBasicBabies[baby.SubType]
			}
		else
			local babyToSet = 1
			
			if baby.Variant == p20FamiliarVariant.SPECIAL_BABY then
				if player:HasCollectible(CollectibleType.COLLECTIBLE_BFFS) then
					local onlyGoodBabies = {}
					for i=1, #p20ContentPackSpecialBabies do
						if not p20ContentPackSpecialBabies[i].IsBadBaby then
							onlyGoodBabies[#onlyGoodBabies+1] = i
						end
					end
					
					babyToSet = onlyGoodBabies[p20.GetRandomNumber(1, #onlyGoodBabies, player:GetCollectibleRNG(p20CollectibleType.COLLECTIBLE_SPECIAL_BABIES))]
				else
					babyToSet = p20.GetRandomNumber(1, #p20ContentPackSpecialBabies, player:GetCollectibleRNG(p20CollectibleType.COLLECTIBLE_SPECIAL_BABIES))
				end
				
				baby.SubType = babyToSet
				data.babyID = babyToSet
				data.babyData = p20ContentPackSpecialBabies[babyToSet]
				
			elseif baby.Variant == p20FamiliarVariant.BASIC_BABY then
				babyToSet = p20.GetRandomNumber(1, #p20ContentPackBasicBabies, player:GetCollectibleRNG(p20CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX))
				
				baby.SubType = babyToSet
				data.babyID = babyToSet
				data.babyData = {
					Name = "Basic Baby",
					Spritesheet = p20ContentPackBasicBabies[babyToSet]
				}
			end
		end
		
		if data.babyData.Spritesheet then
			sprite:ReplaceSpritesheet(0, "gfx/Characters/Player2/" .. data.babyData.Spritesheet)
			sprite:ReplaceSpritesheet(1, "gfx/Characters/Player2/" .. data.babyData.Spritesheet)
			sprite:LoadGraphics()
			
			if p20ContentPackDrippingBabies[data.babyData.Spritesheet] then
				sprite:PlayOverlay("Dripping", true)
				sprite:SetOverlayRenderPriority(true)
			end
		end
	end
	
	data.fireDelay = data.fireDelay or 30
	data.fireCountdown = data.fireCountdown or 0
	
	if baby.Variant == p20FamiliarVariant.BASIC_BABY then
		data.fireDelay = player.MaxFireDelay * 3
	end
	
	data.fireDelay = math.max(5,data.fireDelay)
	
	if data.fireCountdown > 0 then
		data.fireCountdown = data.fireCountdown - 1
	end

	local shootDirection = player:GetFireDirection()
	local isPlayingShootAnimation = false
	for _, checkAnimation in pairs(shootAnimations) do
		if sprite:IsPlaying(checkAnimation) then
			isPlayingShootAnimation = true
			break
		end
	end
	
	local spriteFrame = sprite:GetFrame()
	
	local animationTable = floatAnimations
	local playDirection = shootDirection
	local isShooting = false
	if shootDirection == Direction.NO_DIRECTION then
		if isPlayingShootAnimation and data.ShootDirection then
			playDirection = data.ShootDirection
			isShooting = true
		else
			playDirection = Direction.DOWN
		end
	else
		if data.fireCountdown <= 0 then
			data.fireCountdown = data.fireDelay
			local tear = baby:FireProjectile(shootVectors[shootDirection])
			
			tear.TearFlags = tear.TearFlags | player.TearFlags
			tear.Color = tear.Color * player.TearColor
			tear.CollisionDamage = (tear.CollisionDamage / 7) * player.Damage
			tear.Scale = (tear.CollisionDamage + 3.5) * 0.125
			
			if data.babyData.TearFlags then
				tear.TearFlags = tear.TearFlags | data.babyData.TearFlags
			end
			
			if data.babyData.TearColor then
				tear.Color = tear.Color * data.babyData.TearColor
			end
			
			if data.babyData.OnShoot then
				data.babyData.OnShoot(baby, data, player, tear)
			end
		end
		isShooting = true
	end
	
	if isShooting and (shootDirection == Direction.NO_DIRECTION or data.fireCountdown == data.fireDelay or (isPlayingShootAnimation and spriteFrame <= 10)) then
		animationTable = shootAnimations
	end

	for direction, animationToPlay in pairs(animationTable) do
		if direction == playDirection then
			if not sprite:IsPlaying(animationToPlay) then
				data.ShootDirection = nil
				if isShooting then
					data.ShootDirection = playDirection
				end
				sprite:Play(animationToPlay, true)
			end
		end
	end

	if data.babyData.OnUpdate then
		data.babyData.OnUpdate(baby, data, player)
	end
	
	if not data.inFollowers then
		baby:AddToFollowers()
		data.inFollowers = true
	end
	baby:FollowParent()
end
p20ContentPack:AddCallback(ModCallbacks.MC_FAMILIAR_UPDATE, specialBabyAI, p20FamiliarVariant.SPECIAL_BABY)
p20ContentPack:AddCallback(ModCallbacks.MC_FAMILIAR_UPDATE, specialBabyAI, p20FamiliarVariant.BASIC_BABY)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_NEW_ROOM, function()
	for _, baby in pairs(Isaac.FindByType(EntityType.ENTITY_FAMILIAR, p20FamiliarVariant.SPECIAL_BABY, -1, false, false)) do
		baby = baby:ToFamiliar()
		local data = p20ContentPack.GetData(baby)
		if data.babyData.OnNewRoom then
			data.babyData.OnNewRoom(baby, data, baby.Player)
		end
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_ENTITY_TAKE_DMG, function(_, entity, amount, flags, source, countdown)
	for _, baby in pairs(Isaac.FindByType(EntityType.ENTITY_FAMILIAR, p20FamiliarVariant.SPECIAL_BABY, -1, false, false)) do
		baby = baby:ToFamiliar()
		if GetPtrHash(entity) == GetPtrHash(baby.Player) then
			local data = p20ContentPack.GetData(baby)
			if data.babyData.OnPlayerDamaged then
				data.babyData.OnPlayerDamaged(baby, data, baby.Player, amount, flags, source)
			end
		end
	end
end, EntityType.ENTITY_PLAYER)

--fly orbital
p20ContentPack:AddCallback(ModCallbacks.MC_FAMILIAR_UPDATE, function(_, fly)
	local data = p20ContentPack.GetData(fly)
	
	for i,proj in ipairs(Isaac.FindByType(EntityType.ENTITY_PROJECTILE, -1, -1, true)) do
		if fly.Position:Distance(proj.Position) < proj.Size + fly.Size + 3 then
			proj:Die()
		end
	end
	
	if not data.StayAlive then
		data.StayAlive = 10
	end
	data.StayAlive = data.StayAlive - 1
	if data.StayAlive <= 0 then
		fly:Remove()
	end
end, p20FamiliarVariant.SPECIAL_BABY_FLY_ORBITAL)

--buddy in a box replacement
p20ContentPack:AddCallback(ModCallbacks.MC_POST_PICKUP_RENDER, function(_, pickup, offest)
	--replace buddy in a box collectibles in the room with the other buddy in a box
	if p20.ModSave.Config.Content_BuddyBox_Reimplement then
		if pickup.SubType == CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX then
			pickup:ToPickup():Morph(pickup.Type, pickup.Variant, p20CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX, true)
		end
	else
		if pickup.SubType == p20CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX then
			pickup:ToPickup():Morph(pickup.Type, pickup.Variant, CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX, true)
		end
	end
end, PickupVariant.PICKUP_COLLECTIBLE)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_RENDER, function()
	--replace buddy in a box collectibles any players have with the other buddy in a box
	if p20.ModSave.Config.Content_BuddyBox_Reimplement then
		for _, player in pairs(p20.GetPlayersWithCollectible(CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX)) do
			player:RemoveCollectible(CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX)
			player:AddCollectible(p20CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX, 0, false)
		end
	else
		for _, player in pairs(p20.GetPlayersWithCollectible(CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX)) do
			player:RemoveCollectible(p20CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX)
			player:AddCollectible(CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX, 0, false)
		end
	end
end)

--unlocks
p20ContentPack:AddCallback(ModCallbacks.MC_POST_UPDATE, function()
	local uniqueFams = {}
	local uniqueFamsCount = 0
	for _, familiar in pairs(Isaac.FindByType(EntityType.ENTITY_FAMILIAR, -1, -1, false, false)) do
		if not uniqueFams[familiar.Variant] then
			uniqueFams[familiar.Variant] = true
			uniqueFamsCount = uniqueFamsCount + 1
		end
	end
	if uniqueFamsCount >= 10 and not p20.ModSave.Unlocks.ContentPack_SpecialBabies then
		p20.ModSave.Unlocks.ContentPack_SpecialBabies = true
		p20.DoAchievement("gfx/ui/achievement/piberpack/special_babies.png")
		p20.Save()
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_NEW_ROOM, function()
	if not p20.ModSave.Unlocks.ContentPack_SpecialBabies then
		p20.ItemPool:RemoveCollectible(p20CollectibleType.COLLECTIBLE_SPECIAL_BABIES)
	end
end)

__eidItemDescriptions[p20CollectibleType.COLLECTIBLE_SPECIAL_BABIES] = "Grants a familiar version of a random special Co-Op Baby#Copies tear effects, has half damage, and a third of the player's fire delay#The familiar has effects that are similar to the Co-Op Baby's effect#Will be randomized again every floor"
__eidItemDescriptions[p20CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX] = "Grants a familiar version of a random non-special Co-Op Baby#Copies tear effects, has half damage, and a third of the player's fire delay#Will be randomized again every floor"

p20.AddCustomCallback(p20ContentPack, p20Callbacks.MC_POST_FIRST_GAME_START, function(_, isSaveGame)
	if p20ChaosBlacklist then
		p20ChaosBlacklist[#p20ChaosBlacklist+1] = p20CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX
	end
end)


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally