local function floodPreUpdate(npc, isWalking)
	if npc.Variant == p20NPCVariant.FLOOD or npc.Variant == p20NPCVariant.FLOOD_SCARRED then
		local sprite = npc:GetSprite()
		if npc.State == 8 and sprite:IsPlaying("Shoot") and (isWalking or npc.HitPoints >= npc.MaxHitPoints) then
			
			if isWalking then
				npc.Velocity = npc.Velocity * 0.8
			else
				npc.Velocity = p20.VECTOR_ZERO
			end
			
			if sprite:IsEventTriggered("Shoot") then
				npc:PlaySound(SoundEffect.SOUND_BLOODSHOOT, 0.8, 0, false, 1)
			end
		
			if (sprite:IsEventTriggered("Shoot") or sprite:WasEventTriggered("Shoot"))
			and not (sprite:IsEventTriggered("Stop") or sprite:WasEventTriggered("Stop"))
			and npc.FrameCount%2 == 0 then
			
				local params = ProjectileParams()
				params.HeightModifier = params.HeightModifier + 20
				params.FallingSpeedModifier = -35
				params.FallingAccelModifier = 1
				
				local velocityMaxRange = 25
				if npc.Variant == p20NPCVariant.FLOOD_SCARRED then
					velocityMaxRange = 20
				end
				
				npc:FireProjectiles(npc.Position, RandomVector()*(math.random(1,velocityMaxRange)*0.1), 0, params)
				
			end
			
			return true
		end
	end
end

p20.AddCustomCallback(p20, ModCallbacks.MC_PRE_NPC_UPDATE, function(_, npc)
	if floodPreUpdate(npc, false) == true then
		return true
	end
end, EntityType.ENTITY_BOIL)

p20.AddCustomCallback(p20, ModCallbacks.MC_PRE_NPC_UPDATE, function(_, npc)
	if floodPreUpdate(npc, true) == true then
		return true
	end
end, EntityType.ENTITY_WALKINGBOIL)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_ENTITY_REMOVE, function(_, entity)
	if not p20.Game:IsPaused() and (entity.SpawnerType == EntityType.ENTITY_BOIL or entity.SpawnerType == EntityType.ENTITY_WALKINGBOIL) and entity.SpawnerVariant == p20NPCVariant.FLOOD_SCARRED then
		local creep = Isaac.Spawn(EntityType.ENTITY_EFFECT, EffectVariant.CREEP_RED, 0, entity.Position, p20.VECTOR_ZERO, entity):ToEffect()
		local scale = creep.Scale * 1.5
		creep.SpriteScale = Vector(scale, scale)
		creep:Update()
	end
end, EntityType.ENTITY_PROJECTILE)


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally