p20ContentPack.SlipperyPoops = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DIP] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DIP][0] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DIP][0][p20NPCSubType.SLIPPERY_DIP] = {VelocityMult = 1.01, DeathCreepSize = 1.0, FloodedCreepSize = 0.8, FloodedVelocityMult = 1.025}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DIP][1] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DIP][1][p20NPCSubType.SLIPPERY_CORN] = {VelocityMult = 1.01, DeathCreepSize = 1.0, FloodedCreepSize = 0.8, FloodedVelocityMult = 1.025}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DIP][2] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DIP][2][0] = {VelocityMult = 1.01, DeathCreepSize = 1.0, FloodedCreepSize = 0.8, FloodedVelocityMult = 1.025}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_SQUIRT] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_SQUIRT][p20NPCVariant.SLIPPERY_SQUIRT] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_SQUIRT][p20NPCVariant.SLIPPERY_SQUIRT][0] = {VelocityMult = 1.01, DeathCreepSize = 1.35, FloodedCreepSize = 1.0, FloodedVelocityMult = 1.025}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DINGA] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DINGA][p20NPCVariant.SLIPPERY_DINGA] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DINGA][p20NPCVariant.SLIPPERY_DINGA][0] = {VelocityMult = 1.01, DeathCreepSize = 1.8, FloodedCreepSize = 1.35, FloodedVelocityMult = 1.025}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_CORN_MINE] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_CORN_MINE][0] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_CORN_MINE][0][0] = {DeathCreepSize = 1.35, FloodedCreepSize = 1.0}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DINGLE] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DINGLE][1] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_DINGLE][1][0] = {FloodedCreepSize = 1.0}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_BROWNIE] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_BROWNIE][0] = {}
p20ContentPack.SlipperyPoops[EntityType.ENTITY_BROWNIE][0][0] = {FloodedCreepSize = 1.35}

p20ContentPack.SlipperyPoopReplacements = {}
p20ContentPack.SlipperyPoopReplacements[EntityType.ENTITY_DIP] = {}
p20ContentPack.SlipperyPoopReplacements[EntityType.ENTITY_DIP][0] = {}
p20ContentPack.SlipperyPoopReplacements[EntityType.ENTITY_DIP][0][0] = {EntityType.ENTITY_DIP,0,p20NPCSubType.SLIPPERY_DIP}
p20ContentPack.SlipperyPoopReplacements[EntityType.ENTITY_DIP][1] = {}
p20ContentPack.SlipperyPoopReplacements[EntityType.ENTITY_DIP][1][0] = {EntityType.ENTITY_DIP,1,p20NPCSubType.SLIPPERY_CORN}
p20ContentPack.SlipperyPoopReplacements[EntityType.ENTITY_SQUIRT] = {}
p20ContentPack.SlipperyPoopReplacements[EntityType.ENTITY_SQUIRT][0] = {}
p20ContentPack.SlipperyPoopReplacements[EntityType.ENTITY_SQUIRT][0][0] = {EntityType.ENTITY_SQUIRT,p20NPCVariant.SLIPPERY_SQUIRT,0}
p20ContentPack.SlipperyPoopReplacements[EntityType.ENTITY_DINGA] = {}
p20ContentPack.SlipperyPoopReplacements[EntityType.ENTITY_DINGA][0] = {}
p20ContentPack.SlipperyPoopReplacements[EntityType.ENTITY_DINGA][0][0] = {EntityType.ENTITY_DINGA,p20NPCVariant.SLIPPERY_DINGA,0}

p20ContentPack:AddCallback(ModCallbacks.MC_POST_NPC_INIT, function(_, npc)
	local npcType = npc.Type
	local variant = npc.Variant
	local subType = npc.SubType
	
	if p20ContentPack.SlipperyPoopReplacements[npcType] and p20ContentPack.SlipperyPoopReplacements[npcType][variant] and p20ContentPack.SlipperyPoopReplacements[npcType][variant][subType] then
	
		local spawnData = p20.GetSpawnData(npc)
		local spawnerType = 0
		local spawnerVarant = 0
		local spawnerSubType = 0
		if spawnData and spawnData.SpawnerEntity then
			local spawner = spawnData.SpawnerEntity
			spawnerType = spawner.Type
			spawnerVarant = spawner.Variant
			spawnerSubType = spawner.SubType
		end
	
		local backdrop = p20.Room:GetBackdropType()
		
		if (p20ContentPack.SlipperyPoops[spawnerType] and p20ContentPack.SlipperyPoops[spawnerType][spawnerVarant] and p20ContentPack.SlipperyPoops[spawnerType][spawnerVarant][spawnerSubType])
		or ((p20.ModSave.Config.Content_SlipperyPoop_ReplacePoops and backdrop == p20Backdrop.FLOODED_CAVES) and p20.Room:GetFrameCount() <= 2) then
			p20.ReplaceEntity(npc, table.unpack(p20ContentPack.SlipperyPoopReplacements[npcType][variant][subType]))
		end
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_NPC_UPDATE, function(_, npc)
	local npcType = npc.Type
	local variant = npc.Variant
	local subType = npc.SubType
	
	if p20ContentPack.SlipperyPoops[npcType] and p20ContentPack.SlipperyPoops[npcType][variant] and p20ContentPack.SlipperyPoops[npcType][variant][subType] then
	
		local slipperyData = p20ContentPack.SlipperyPoops[npcType][variant][subType]
		local backdrop = p20.Room:GetBackdropType()
		
		if p20.Room:HasWater() then
		
			if npc.FrameCount%5 == 0 then
			
				local dontSpawnCreep = false
				if slipperyData.FloodedCreepSize and slipperyData.FloodedCreepSize > 0 then
					for _, creep in ipairs(Isaac.FindByType(EntityType.ENTITY_EFFECT, EffectVariant.CREEP_SLIPPERY_BROWN, 0, true, false)) do
						creep = creep:ToEffect()
						if creep.Position:Distance(npc.Position) < 20 and creep.FrameCount <= 30 then
							dontSpawnCreep = true
							break
						end
					end
				end
				
				if not dontSpawnCreep then
					local creep = Isaac.Spawn(EntityType.ENTITY_EFFECT, EffectVariant.CREEP_SLIPPERY_BROWN, 0, npc.Position, p20.VECTOR_ZERO, npc):ToEffect()
					local scale = creep.Scale * slipperyData.FloodedCreepSize
					creep.SpriteScale = Vector(scale, scale)
					creep:Update()
				end
				
			end
			
			if slipperyData.FloodedVelocityMult and slipperyData.FloodedVelocityMult > 1 then
				npc.Velocity = npc.Velocity * slipperyData.FloodedVelocityMult
			elseif slipperyData.VelocityMult and slipperyData.VelocityMult > 1 then
				npc.Velocity = npc.Velocity * slipperyData.VelocityMult
			end
			
		else
		
			if slipperyData.VelocityMult and slipperyData.VelocityMult > 1 then
				npc.Velocity = npc.Velocity * slipperyData.VelocityMult
			end
			
		end
		
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_NPC_DEATH, function(_, npc)
	local npcType = npc.Type
	local variant = npc.Variant
	local subType = npc.SubType
	
	if p20ContentPack.SlipperyPoops[npcType] and p20ContentPack.SlipperyPoops[npcType][variant] and p20ContentPack.SlipperyPoops[npcType][variant][subType] then
	
		local slipperyData = p20ContentPack.SlipperyPoops[npcType][variant][subType]
	
		p20.Schedule(1, true, function(npc)
			for _, entity in pairs(Isaac.FindInRadius(npc.Position, 100, EntityPartition.ENEMY)) do
				local entType = entity.Type
				local entVarant = entity.Variant
				local entSubType = entity.SubType
				if entity.FrameCount <= 2 and p20ContentPack.SlipperyPoopReplacements[entType] and p20ContentPack.SlipperyPoopReplacements[entType][entVarant] and p20ContentPack.SlipperyPoopReplacements[entType][entVarant][entSubType] then
					p20.ReplaceEntity(entity, table.unpack(p20ContentPack.SlipperyPoopReplacements[entType][entVarant][entSubType]))
				end
			end
		end, npc)
		
		if slipperyData.DeathCreepSize and slipperyData.DeathCreepSize > 0 then
			local creep = Isaac.Spawn(EntityType.ENTITY_EFFECT, EffectVariant.CREEP_SLIPPERY_BROWN, 0, npc.Position, p20.VECTOR_ZERO, npc):ToEffect()
			local scale = creep.Scale * slipperyData.DeathCreepSize
			creep.SpriteScale = Vector(scale, scale)
			creep:Update()
		end
		
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_NPC_UPDATE, function(_, npc)
	if npc.Variant == p20NPCVariant.SLIPPERY_DINGA then
		local sprite = npc:GetSprite()
		if sprite:IsPlaying("Attack") then
			
			if sprite:GetFrame() == 27 then
				--remove projectiles
				for _, entity in pairs(Isaac.FindInRadius(npc.Position, 100, EntityPartition.BULLET)) do
					if entity.FrameCount <= 2 and entity.Type == EntityType.ENTITY_PROJECTILE and entity.Variant == ProjectileVariant.PROJECTILE_PUKE then
						entity:Remove()
					end
				end
			end
			
			if sprite:GetFrame() == 30 then
				--spawn creep
				local creep = Isaac.Spawn(EntityType.ENTITY_EFFECT, EffectVariant.CREEP_SLIPPERY_BROWN, 0, npc.Position, p20.VECTOR_ZERO, npc):ToEffect()
				local scale = creep.Scale * 2
				creep.SpriteScale = Vector(scale, scale)
				creep:Update()
			end
			
		end
	end
end, EntityType.ENTITY_DINGA)

local colorSlipperyCreepScarredWombWater = Color(0,0,0,1,255,255,0)
p20ContentPack:AddCallback(ModCallbacks.MC_POST_EFFECT_RENDER, function(_, eff)
	if not p20.Game:IsPaused() then
		local data = p20ContentPack.GetData(eff)
		
		if not data.Init then
			local backdrop = p20.Room:GetBackdropType()
			
			if backdrop == p20Backdrop.SCARRED_WOMB and p20.Room:HasWater() then
				local sprite = eff:GetSprite()
				sprite.Color = colorSlipperyCreepScarredWombWater
				eff:Update()
			end
			data.Init = true
		end
	end
end, EffectVariant.CREEP_SLIPPERY_BROWN)


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally