p20ContentPack.BaseArcadePool = { --base pool
	CollectibleType.COLLECTIBLE_SUPER_BANDAGE,
	CollectibleType.COLLECTIBLE_GAMEKID,
	CollectibleType.COLLECTIBLE_NOTCHED_AXE,
	CollectibleType.COLLECTIBLE_RAINBOW_BABY,
	CollectibleType.COLLECTIBLE_PORTABLE_SLOT,
	CollectibleType.COLLECTIBLE_SMB_SUPER_FAN,
	CollectibleType.COLLECTIBLE_3_DOLLAR_BILL,
	CollectibleType.COLLECTIBLE_TELEPATHY_BOOK,
	CollectibleType.COLLECTIBLE_GNAWED_LEAF,
	CollectibleType.COLLECTIBLE_TRINITY_SHIELD,
	CollectibleType.COLLECTIBLE_MISSING_NO,
	CollectibleType.COLLECTIBLE_HOW_TO_JUMP,
	CollectibleType.COLLECTIBLE_PAY_TO_PLAY,
	CollectibleType.COLLECTIBLE_MAGIC_FINGERS,
	CollectibleType.COLLECTIBLE_UNDEFINED,
	CollectibleType.COLLECTIBLE_SPIDER_MOD,
	CollectibleType.COLLECTIBLE_GB_BUG,
	CollectibleType.COLLECTIBLE_ANALOG_STICK,
	CollectibleType.COLLECTIBLE_FINGER,
	CollectibleType.COLLECTIBLE_DATAMINER,
	CollectibleType.COLLECTIBLE_BUTTER_BEAN,
	CollectibleType.COLLECTIBLE_YO_LISTEN,
	CollectibleType.COLLECTIBLE_POKE_GO,
	CollectibleType.COLLECTIBLE_FRIEND_BALL,
	CollectibleType.COLLECTIBLE_BROKEN_MODEM,
	CollectibleType.COLLECTIBLE_BOZO,
	CollectibleType.COLLECTIBLE_BUDDY_IN_A_BOX,
	CollectibleType.COLLECTIBLE_MR_ME,
	CollectibleType.COLLECTIBLE_LIL_SPEWER,
	CollectibleType.COLLECTIBLE_SHOOP_DA_WHOOP,
	CollectibleType.COLLECTIBLE_STEVEN,
	CollectibleType.COLLECTIBLE_DR_FETUS,
	CollectibleType.COLLECTIBLE_EPIC_FETUS,
	CollectibleType.COLLECTIBLE_BOBBY_BOMB,
	CollectibleType.COLLECTIBLE_BOMBER_BOY,
	CollectibleType.COLLECTIBLE_BUM_FRIEND,
	CollectibleType.COLLECTIBLE_LITTLE_CHAD,
	CollectibleType.COLLECTIBLE_BUMBO,
	CollectibleType.COLLECTIBLE_BALL_OF_BANDAGES,
	CollectibleType.COLLECTIBLE_CUBE_OF_MEAT,
	CollectibleType.COLLECTIBLE_MINI_MUSH,
	CollectibleType.COLLECTIBLE_MAGIC_MUSHROOM,
	CollectibleType.COLLECTIBLE_ONE_UP,
	CollectibleType.COLLECTIBLE_THERES_OPTIONS,
	CollectibleType.COLLECTIBLE_MORE_OPTIONS,
	CollectibleType.COLLECTIBLE_BEST_FRIEND,
	CollectibleType.COLLECTIBLE_BOBS_BRAIN,
	CollectibleType.COLLECTIBLE_ANGELIC_PRISM,
	CollectibleType.COLLECTIBLE_CURSE_OF_THE_TOWER
}

p20ContentPack.ArcadeExclusives = { --removes items from pool specified
	--nothing yet
}

p20ContentPack:AddCallback(ModCallbacks.MC_PRE_GET_COLLECTIBLE, function(_, poolType, decrease, seed)
	if poolType == ItemPoolType.POOL_TREASURE and p20.Room:GetType() == RoomType.ROOM_ARCADE and (#p20.ModSave.Run.ArcadePool > 0 or not p20.ModSave.Run.ArcadePoolCreated) then
		
		--fill the arcade pool save if it wasnt filled before
		--we do this here and not on game start because we want other mods to have a chance to add items to the pool
		if not p20.ModSave.Run.ArcadePoolCreated then
			p20.ModSave.Run.ArcadePool = p20.CopyTable(p20ContentPack.BaseArcadePool)
			p20.ModSave.Run.ArcadePoolCreated = true
		end
	
		--remove already seen items from the pool
		for i, itemID in ripairs(p20.ModSave.Run.ArcadePool) do
			if p20.HasSeenCollectible(itemID) then
				table.remove(p20.ModSave.Run.ArcadePool, i)
			end
		end
		
		--get a random item from the pool
		local indexInPool = p20.GetRandomNumber(1, #p20.ModSave.Run.ArcadePool, seed)
		local itemToReturn = p20.ModSave.Run.ArcadePool[indexInPool]
		
		--remove it from the pools
		table.remove(p20.ModSave.Run.ArcadePool, indexInPool)
		p20.ItemPool:RemoveCollectible(itemToReturn)
		
		--return the item
		return itemToReturn
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_GET_COLLECTIBLE, function(_, itemID, poolType, decrease, seed)
	if p20ContentPack.ArcadeExclusives and p20ContentPack.ArcadeExclusives[poolType] and p20ContentPack.ArcadeExclusives[poolType][itemID] then
		return p20.ItemPool:GetCollectible(poolType, decrease, seed)
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, function(_, isSaveGame)
	if not isSaveGame then
		
		--add some content pack items to the bedroom pool
		if not p20.ModSave.Unlocks.ContentPack_SpecialBabies then
			p20ContentPack.BaseArcadePool[#p20ContentPack.BaseArcadePool+1] = p20CollectibleType.COLLECTIBLE_SPECIAL_BABIES
		end
		
		--add some revelations items to the arcade pool
		if REVEL and REVEL.ITEM then
			p20ContentPack.BaseArcadePool[#p20ContentPack.BaseArcadePool+1] = REVEL.ITEM.ROBOT.id
			p20ContentPack.BaseArcadePool[#p20ContentPack.BaseArcadePool+1] = REVEL.ITEM.WAKA_WAKA.id
			p20ContentPack.BaseArcadePool[#p20ContentPack.BaseArcadePool+1] = REVEL.ITEM.OOPS.id
		end
		
	end
end)


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally