p20ContentPack.BaseBarrenPool = { --base pool
	CollectibleType.COLLECTIBLE_HALO_OF_FLIES,
	CollectibleType.COLLECTIBLE_TRANSCENDENCE,
	CollectibleType.COLLECTIBLE_WIRE_COAT_HANGER,
	CollectibleType.COLLECTIBLE_BIBLE,
	CollectibleType.COLLECTIBLE_POOP,
	CollectibleType.COLLECTIBLE_HOURGLASS,
	CollectibleType.COLLECTIBLE_LADDER,
	CollectibleType.COLLECTIBLE_GHOST_BABY,
	CollectibleType.COLLECTIBLE_CANDLE,
	CollectibleType.COLLECTIBLE_DADS_KEY,
	CollectibleType.COLLECTIBLE_ABEL,
	CollectibleType.COLLECTIBLE_LOST_CONTACT,
	CollectibleType.COLLECTIBLE_OLD_BANDAGE,
	CollectibleType.COLLECTIBLE_BLACK_CANDLE,
	CollectibleType.COLLECTIBLE_DRY_BABY,
	CollectibleType.COLLECTIBLE_LIL_HAUNT,
	CollectibleType.COLLECTIBLE_SISSY_LONGLEGS,
	CollectibleType.COLLECTIBLE_PUNCHING_BAG,
	CollectibleType.COLLECTIBLE_BOOK_OF_SECRETS,
	CollectibleType.COLLECTIBLE_BOX_OF_SPIDERS,
	CollectibleType.COLLECTIBLE_RED_CANDLE,
	CollectibleType.COLLECTIBLE_BLUE_BOX,
	CollectibleType.COLLECTIBLE_TORN_PHOTO,
	CollectibleType.COLLECTIBLE_BURSTING_SACK,
	CollectibleType.COLLECTIBLE_EDENS_BLESSING,
	CollectibleType.COLLECTIBLE_GLOWING_HOUR_GLASS,
	CollectibleType.COLLECTIBLE_NIGHT_LIGHT,
	CollectibleType.COLLECTIBLE_LEAD_PENCIL,
	CollectibleType.COLLECTIBLE_SHARD_OF_GLASS,
	CollectibleType.COLLECTIBLE_TAROT_CLOTH,
	CollectibleType.COLLECTIBLE_DADS_LOST_COIN,
	CollectibleType.COLLECTIBLE_MOLDY_BREAD,
	CollectibleType.COLLECTIBLE_CONTAGION,
	CollectibleType.COLLECTIBLE_DULL_RAZOR,
	CollectibleType.COLLECTIBLE_METRONOME,
	CollectibleType.COLLECTIBLE_DADS_RING
}

p20ContentPack.BarrenExclusives = { --removes items from pool specified
	[ItemPoolType.POOL_SHOP] = {
		[CollectibleType.COLLECTIBLE_NIGHT_LIGHT] = true,
		[CollectibleType.COLLECTIBLE_TAROT_CLOTH] = true
	},
	[ItemPoolType.POOL_DEVIL] = {
		[CollectibleType.COLLECTIBLE_TAROT_CLOTH] = true
	}
}

p20ContentPack:AddCallback(ModCallbacks.MC_PRE_GET_COLLECTIBLE, function(_, poolType, decrease, seed)
	if poolType == ItemPoolType.POOL_TREASURE and p20.Room:GetType() == RoomType.ROOM_BARREN and (#p20.ModSave.Run.BarrenPool > 0 or not p20.ModSave.Run.BarrenPoolCreated) then
		
		--fill the barren pool save if it wasnt filled before
		--we do this here and not on game start because we want other mods to have a chance to add items to the pool
		if not p20.ModSave.Run.BarrenPoolCreated then
			p20.ModSave.Run.BarrenPool = p20.CopyTable(p20ContentPack.BaseBarrenPool)
			p20.ModSave.Run.BarrenPoolCreated = true
		end
	
		--remove already seen items from the pool
		for i, itemID in ripairs(p20.ModSave.Run.BarrenPool) do
			if p20.HasSeenCollectible(itemID) then
				table.remove(p20.ModSave.Run.BarrenPool, i)
			end
		end
		
		--get a random item from the pool
		local indexInPool = p20.GetRandomNumber(1, #p20.ModSave.Run.BarrenPool, seed)
		local itemToReturn = p20.ModSave.Run.BarrenPool[indexInPool]
		
		--remove it from the pools
		table.remove(p20.ModSave.Run.BarrenPool, indexInPool)
		p20.ItemPool:RemoveCollectible(itemToReturn)
		
		--return the item
		return itemToReturn
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_GET_COLLECTIBLE, function(_, itemID, poolType, decrease, seed)
	if p20ContentPack.BarrenExclusives and p20ContentPack.BarrenExclusives[poolType] and p20ContentPack.BarrenExclusives[poolType][itemID] then
		return p20.ItemPool:GetCollectible(poolType, decrease, seed)
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, function(_, isSaveGame)
	if not isSaveGame then
		
		--add some revelations items to the barren pool
		if REVEL and REVEL.ITEM then
			p20ContentPack.BaseBarrenPool[#p20ContentPack.BaseBarrenPool+1] = REVEL.ITEM.TAMPON.id
			p20ContentPack.BaseBarrenPool[#p20ContentPack.BaseBarrenPool+1] = REVEL.ITEM.BCONTROL.id
			p20ContentPack.BaseBarrenPool[#p20ContentPack.BaseBarrenPool+1] = REVEL.ITEM.MUSIC_BOX.id
		end
		
	end
end)


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally