p20ContentPack.BaseBedroomPool = { --base pool
	CollectibleType.COLLECTIBLE_BROTHER_BOBBY,
	CollectibleType.COLLECTIBLE_WIRE_COAT_HANGER,
	CollectibleType.COLLECTIBLE_BIBLE,
	CollectibleType.COLLECTIBLE_SISTER_MAGGY,
	CollectibleType.COLLECTIBLE_ROSARY,
	CollectibleType.COLLECTIBLE_D6,
	CollectibleType.COLLECTIBLE_BEST_FRIEND,
	CollectibleType.COLLECTIBLE_PIGGY_BANK,
	CollectibleType.COLLECTIBLE_ISAACS_HEART,
	CollectibleType.COLLECTIBLE_ISAACS_TEARS,
	CollectibleType.COLLECTIBLE_TORN_PHOTO,
	CollectibleType.COLLECTIBLE_MR_DOLLY,
	CollectibleType.COLLECTIBLE_NIGHT_LIGHT,
	CollectibleType.COLLECTIBLE_PJS,
	CollectibleType.COLLECTIBLE_BINKY,
	CollectibleType.COLLECTIBLE_DEPRESSION,
	CollectibleType.COLLECTIBLE_CAMO_UNDIES,
	CollectibleType.COLLECTIBLE_MYSTERY_GIFT,
	CollectibleType.COLLECTIBLE_SCHOOLBAG,
	CollectibleType.COLLECTIBLE_BLANKET
}

p20ContentPack.BedroomExclusives = { --removes items from pool specified
	[ItemPoolType.POOL_SHOP] = {
		[CollectibleType.COLLECTIBLE_NIGHT_LIGHT] = true,
		[CollectibleType.COLLECTIBLE_BLANKET] = true
	}
}

p20ContentPack:AddCallback(ModCallbacks.MC_PRE_GET_COLLECTIBLE, function(_, poolType, decrease, seed)
	if poolType == ItemPoolType.POOL_TREASURE and p20.Room:GetType() == RoomType.ROOM_ISAACS and (#p20.ModSave.Run.BedroomPool > 0 or not p20.ModSave.Run.BedroomPoolCreated) then
		
		--fill the bedroom pool save if it wasnt filled before
		--we do this here and not on game start because we want other mods to have a chance to add items to the pool
		if not p20.ModSave.Run.BedroomPoolCreated then
			p20.ModSave.Run.BedroomPool = p20.CopyTable(p20ContentPack.BaseBedroomPool)
			p20.ModSave.Run.BedroomPoolCreated = true
		end
	
		--remove already seen items from the pool
		for i, itemID in ripairs(p20.ModSave.Run.BedroomPool) do
			if p20.HasSeenCollectible(itemID) then
				table.remove(p20.ModSave.Run.BedroomPool, i)
			end
		end
		
		--get a random item from the pool
		local indexInPool = p20.GetRandomNumber(1, #p20.ModSave.Run.BedroomPool, seed)
		local itemToReturn = p20.ModSave.Run.BedroomPool[indexInPool]
		
		--remove it from the pools
		table.remove(p20.ModSave.Run.BedroomPool, indexInPool)
		p20.ItemPool:RemoveCollectible(itemToReturn)
		
		--return the item
		return itemToReturn
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_GET_COLLECTIBLE, function(_, itemID, poolType, decrease, seed)
	if p20ContentPack.BedroomExclusives and p20ContentPack.BedroomExclusives[poolType] and p20ContentPack.BedroomExclusives[poolType][itemID] then
		return p20.ItemPool:GetCollectible(poolType, decrease, seed)
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, function(_, isSaveGame)
	if not isSaveGame then
		
		--add some content pack items to the bedroom pool
		p20ContentPack.BaseBedroomPool[#p20ContentPack.BaseBedroomPool+1] = p20CollectibleType.COLLECTIBLE_BIRTHDAY_CAKE
		
		--add some revelations items to the bedroom pool
		if REVEL and REVEL.ITEM then
			p20ContentPack.BaseBedroomPool[#p20ContentPack.BaseBedroomPool+1] = REVEL.ITEM.BIRTHDAY_CANDLE.id
			p20ContentPack.BaseBedroomPool[#p20ContentPack.BaseBedroomPool+1] = REVEL.ITEM.MUSIC_BOX.id
		end
		
	end
end)


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally