p20ContentPack.BaseDicePool = { --base pool
	CollectibleType.COLLECTIBLE_D1,
	CollectibleType.COLLECTIBLE_D4,
	CollectibleType.COLLECTIBLE_D100,
	CollectibleType.COLLECTIBLE_D10,
	CollectibleType.COLLECTIBLE_D6,
	CollectibleType.COLLECTIBLE_D7,
	CollectibleType.COLLECTIBLE_D8,
	CollectibleType.COLLECTIBLE_D12,
	CollectibleType.COLLECTIBLE_D20,
	CollectibleType.COLLECTIBLE_DINF
}

p20ContentPack.DiceExclusives = { --removes items from pool specified
	--nothing yet
}

p20ContentPack:AddCallback(ModCallbacks.MC_PRE_GET_COLLECTIBLE, function(_, poolType, decrease, seed)
	if poolType == ItemPoolType.POOL_TREASURE and p20.Room:GetType() == RoomType.ROOM_DICE and (#p20.ModSave.Run.DicePool > 0 or not p20.ModSave.Run.DicePoolCreated) then
		
		--fill the dice room pool save if it wasnt filled before
		--we do this here and not on game start because we want other mods to have a chance to add items to the pool
		if not p20.ModSave.Run.DicePoolCreated then
			p20.ModSave.Run.DicePool = p20.CopyTable(p20ContentPack.BaseDicePool)
			p20.ModSave.Run.DicePoolCreated = true
		end
	
		--remove already seen items from the pool
		for i, itemID in ripairs(p20.ModSave.Run.DicePool) do
			if p20.HasSeenCollectible(itemID) then
				table.remove(p20.ModSave.Run.DicePool, i)
			end
		end
		
		--get a random item from the pool
		local indexInPool = p20.GetRandomNumber(1, #p20.ModSave.Run.DicePool, seed)
		local itemToReturn = p20.ModSave.Run.DicePool[indexInPool]
		
		--remove it from the pools
		table.remove(p20.ModSave.Run.DicePool, indexInPool)
		p20.ItemPool:RemoveCollectible(itemToReturn)
		
		--return the item
		return itemToReturn
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_GET_COLLECTIBLE, function(_, itemID, poolType, decrease, seed)
	if p20ContentPack.DiceExclusives and p20ContentPack.DiceExclusives[poolType] and p20ContentPack.DiceExclusives[poolType][itemID] then
		return p20.ItemPool:GetCollectible(poolType, decrease, seed)
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, function(_, isSaveGame)
	if not isSaveGame then
		
		--add some revelations items to the dice room pool
		if REVEL and REVEL.ITEM then
			p20ContentPack.BaseDicePool[#p20ContentPack.BaseDicePool+1] = REVEL.ITEM.HYPER_DICE.id
		end
		
	end
end)


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally