p20ContentPack.BaseErrorPool = { --base pool
	CollectibleType.COLLECTIBLE_UNDEFINED,
	CollectibleType.COLLECTIBLE_DATAMINER,
	CollectibleType.COLLECTIBLE_GB_BUG,
	CollectibleType.COLLECTIBLE_MISSING_NO
}

p20ContentPack.ErrorExclusives = { --removes items from pool specified
	--nothing yet
}

p20ContentPack:AddCallback(ModCallbacks.MC_PRE_GET_COLLECTIBLE, function(_, poolType, decrease, seed)
	if poolType == ItemPoolType.POOL_TREASURE and p20.Room:GetType() == RoomType.ROOM_ERROR and (#p20.ModSave.Run.ErrorPool > 0 or not p20.ModSave.Run.ErrorPoolCreated) then
		
		local rng = RNG()
		rng:SetSeed(seed, 0)
		
		--error pool works a little different, mosty because its so small. theres only a 1/3 chance for its pool item to spawn
		if p20.GetRandomNumber(1, 3, rng) == 1 then
		
			--fill the error room pool save if it wasnt filled before
			--we do this here and not on game start because we want other mods to have a chance to add items to the pool
			if not p20.ModSave.Run.ErrorPoolCreated then
				p20.ModSave.Run.ErrorPool = p20.CopyTable(p20ContentPack.BaseErrorPool)
				p20.ModSave.Run.ErrorPoolCreated = true
			end
		
			--remove already seen items from the pool
			for i, itemID in ripairs(p20.ModSave.Run.ErrorPool) do
				if p20.HasSeenCollectible(itemID) then
					table.remove(p20.ModSave.Run.ErrorPool, i)
				end
			end
			
			--get a random item from the pool
			local indexInPool = p20.GetRandomNumber(1, #p20.ModSave.Run.ErrorPool, rng)
			local itemToReturn = p20.ModSave.Run.ErrorPool[indexInPool]
			
			--remove it from the pools
			table.remove(p20.ModSave.Run.ErrorPool, indexInPool)
			p20.ItemPool:RemoveCollectible(itemToReturn)
			
			--return the item
			return itemToReturn
			
		end
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_GET_COLLECTIBLE, function(_, itemID, poolType, decrease, seed)
	if p20ContentPack.ErrorExclusives and p20ContentPack.ErrorExclusives[poolType] and p20ContentPack.ErrorExclusives[poolType][itemID] then
		return p20.ItemPool:GetCollectible(poolType, decrease, seed)
	end
end)

p20ContentPack:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, function(_, isSaveGame)
	if not isSaveGame then
		
		--add some revelations items to the error room pool
		if REVEL and REVEL.ITEM then
			p20ContentPack.BaseErrorPool[#p20ContentPack.BaseErrorPool+1] = REVEL.ITEM.HYPER_DICE.id
		end
		
	end
end)


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally