p20ContentPackDefaultUnlocks = {
	ContentPack_DailyDose = false,
	ContentPack_DebitCard = false,
	ContentPack_HolyHearts = false,
	ContentPack_TheHammer = false,
	ContentPack_DivineShroud = false,
	ContentPack_LeakyBatteries = false,
	ContentPack_BatteryTester = false,
	ContentPack_SpecialBabies = false
}
p20.FillTable(p20.DefaultModSave.Unlocks, p20ContentPackDefaultUnlocks)
p20.FillTable(p20.ModSave.Unlocks, p20ContentPackDefaultUnlocks)

local achievementShowcase = Sprite()
achievementShowcase:Load("gfx/ui/achievement/achievements.anm2", true)
achievementShowcase:Play("Idle", true)

local currentAchievementShowcaseSpritesheet = nil
local function changeAchievementShowcaseSpritesheet(spritesheet)
	if currentAchievementShowcaseSpritesheet ~= spritesheet then
		currentAchievementShowcaseSpritesheet = spritesheet
		achievementShowcase:ReplaceSpritesheet(3, spritesheet)
		achievementShowcase:LoadGraphics()
	end
end
changeAchievementShowcaseSpritesheet("gfx/ui/achievement/piberpack/unknown.png")

local function createUnlockInfoText(unlock, text)
	local infoText = "? ? ?"
	
	if unlock then
		infoText = text
	end
	
	return infoText
end

local function showAchievementInPopup(unlock, spritesheet)
	if unlock then
		changeAchievementShowcaseSpritesheet(spritesheet)
	else
		changeAchievementShowcaseSpritesheet("gfx/ui/achievement/piberpack/unknown.png")
	end
	
	achievementShowcase:Render(p20.GetScreenCenterPosition(), p20.VECTOR_ZERO, p20.VECTOR_ZERO)
	
	return ""
end

p20.AddCustomCallback(p20ContentPack, p20Callbacks.MC_POST_FIRST_GAME_START, function(_, isSaveGame)
	if ModConfigMenu then
		ModConfigMenu.AddTitle("piber pack", "Unlocks", "To-Do List:")
		ModConfigMenu.AddSetting("piber pack", "Unlocks", { --DAILY DOSE
			Type = ModConfigMenuOptionType.TEXT,
			ShowStrikeout = function()
				return p20.ModSave.Unlocks.ContentPack_DailyDose
			end,
			Display = "Use 30 stat changing pills",
			Info = function()
				return createUnlockInfoText(p20.ModSave.Unlocks.ContentPack_DailyDose, "Unlocked the Daily Dose active item.")
			end,
			Popup = function()
				return showAchievementInPopup(p20.ModSave.Unlocks.ContentPack_DailyDose, "gfx/ui/achievement/piberpack/daily_dose.png")
			end
		})
		ModConfigMenu.AddSetting("piber pack", "Unlocks", { --DEBIT CARD
			Type = ModConfigMenuOptionType.TEXT,
			ShowStrikeout = function()
				return p20.ModSave.Unlocks.ContentPack_DebitCard
			end,
			Display = "Have 99 coins",
			Info = function()
				return createUnlockInfoText(p20.ModSave.Unlocks.ContentPack_DebitCard, "Unlocked the Debit Card card.")
			end,
			Popup = function()
				return showAchievementInPopup(p20.ModSave.Unlocks.ContentPack_DebitCard, "gfx/ui/achievement/piberpack/debit_card.png")
			end
		})
		ModConfigMenu.AddSetting("piber pack", "Unlocks", { --HOLY HEARTS
			Type = ModConfigMenuOptionType.TEXT,
			ShowStrikeout = function()
				return p20.ModSave.Unlocks.ContentPack_HolyHearts
			end,
			Display = "Have two active Holy Mantle effects",
			Info = function()
				return createUnlockInfoText(p20.ModSave.Unlocks.ContentPack_HolyHearts, "Unlocked the Holy Heart pickup.")
			end,
			Popup = function()
				return showAchievementInPopup(p20.ModSave.Unlocks.ContentPack_HolyHearts, "gfx/ui/achievement/piberpack/holy_hearts.png")
			end
		})
		ModConfigMenu.AddSetting("piber pack", "Unlocks", { --THE HAMMER
			Type = ModConfigMenuOptionType.TEXT,
			ShowStrikeout = function()
				return p20.ModSave.Unlocks.ContentPack_TheHammer
			end,
			Display = "Destroy 20 machines",
			Info = function()
				return createUnlockInfoText(p20.ModSave.Unlocks.ContentPack_TheHammer, "Unlocked the The Hammer active item.")
			end,
			Popup = function()
				return showAchievementInPopup(p20.ModSave.Unlocks.ContentPack_TheHammer, "gfx/ui/achievement/piberpack/the_hammer.png")
			end
		})
		ModConfigMenu.AddSetting("piber pack", "Unlocks", { --DIVINE SHROUD
			Type = ModConfigMenuOptionType.TEXT,
			ShowStrikeout = function()
				return p20.ModSave.Unlocks.ContentPack_DivineShroud
			end,
			Display = function(cursorIsAtThisOption, configMenuInOptions, lastOptionPos)
				local message = "Collect two holy hearts in a run"
				if not p20.ModSave.Unlocks.ContentPack_HolyHearts then
					message = "Collect two ???? ?????? in a run"
				end
				return message
			end,
			Info = function()
				return createUnlockInfoText(p20.ModSave.Unlocks.ContentPack_DivineShroud, "Unlocked the Divine Shroud item.")
			end,
			Popup = function()
				return showAchievementInPopup(p20.ModSave.Unlocks.ContentPack_DivineShroud, "gfx/ui/achievement/piberpack/divine_shroud.png")
			end
		})
		ModConfigMenu.AddSetting("piber pack", "Unlocks", { --LEAKY BATTERIES
			Type = ModConfigMenuOptionType.TEXT,
			ShowStrikeout = function()
				return p20.ModSave.Unlocks.ContentPack_LeakyBatteries
			end,
			Display = "Recharge with 35 batteries",
			Info = function()
				return createUnlockInfoText(p20.ModSave.Unlocks.ContentPack_LeakyBatteries, "Unlocked the Leaky Battery pickup.")
			end,
			Popup = function()
				return showAchievementInPopup(p20.ModSave.Unlocks.ContentPack_LeakyBatteries, "gfx/ui/achievement/piberpack/leaky_battery.png")
			end
		})
		ModConfigMenu.AddSetting("piber pack", "Unlocks", { --BATTERY TESTER
			Type = ModConfigMenuOptionType.TEXT,
			ShowStrikeout = function()
				return p20.ModSave.Unlocks.ContentPack_BatteryTester
			end,
			Display = function(cursorIsAtThisOption, configMenuInOptions, lastOptionPos)
				local message = "Get zapped from leaky batteries 20 times"
				if not p20.ModSave.Unlocks.ContentPack_LeakyBatteries then
					message = "Get ?????? ???? ????? ????????? 20 times"
				end
				return message
			end,
			Info = function()
				return createUnlockInfoText(p20.ModSave.Unlocks.ContentPack_BatteryTester, "Unlocked the Battery Tester item.")
			end,
			Popup = function()
				return showAchievementInPopup(p20.ModSave.Unlocks.ContentPack_BatteryTester, "gfx/ui/achievement/piberpack/battery_tester.png")
			end
		})
		ModConfigMenu.AddSetting("piber pack", "Unlocks", { --BATTERY TESTER
			Type = ModConfigMenuOptionType.TEXT,
			ShowStrikeout = function()
				return p20.ModSave.Unlocks.ContentPack_SpecialBabies
			end,
			Display = "Have 10 unique familiars",
			Info = function()
				return createUnlockInfoText(p20.ModSave.Unlocks.ContentPack_SpecialBabies, "Unlocked the Special Babies! item.")
			end,
			Popup = function()
				return showAchievementInPopup(p20.ModSave.Unlocks.ContentPack_SpecialBabies, "gfx/ui/achievement/piberpack/special_babies.png")
			end
		})
	end
end)


p20.ForceError() --this function doesn't exist, we do this to cause an error intentionally